<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	echo '<script type="text/javascript">parent.location.href="../index.php";</script>';
	exit;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" content="no-cache">
<title><?=VERSION?></title>
<script type="text/javascript" src="../js/dtree.js" /></script>
<link type="text/css" rel="stylesheet" href="../css/dtree.css" />
<link type="text/css" rel="stylesheet" href="../css/common.css" />
<link rel="stylesheet" href="../css/ui-lightness/jquery-ui-custom.css">
<link type="text/css" rel="stylesheet" href="../css/dtree.css" />
<script type="text/javascript" src="../js/jquery.min.js"></script>
<script type="text/javascript" src="../js/jquery-ui.min.js"></script>
<script type="text/javascript" src="../js/common.js"></script>
<script type="text/javascript" src="../js/Calendar.js"></script>
<script type="text/javascript" src="../js/echarts.min.js"></script>
<script type="text/javascript" src="../js/macarons.js"></script>
<script type="text/javascript">
function apptrend_data()
{
	var devid = getdevice();
	var linkid = $("#linkid").val();
	var appid = $("#hidappid").val();

	if (appid == 1044) {
		/*
		 * 1044是所有协议，就不用检查
		 */
		appid = -1;
	}

	var start = $("#start").val();
	var shour = $("#start_hour").val();
	var end = $("#end").val();
	var ehour = $("#end_hour").val();

	var starttime = start + ' '+shour+':0:0';
	var endtime = end + ' '+ehour+':0:0';

	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../App/appgroup_trend_stacking.php',
		data:{devid:devid, linkid:linkid, tmstart:starttime, tmend:endtime, appid: appid, errname:errname},
		type:'post',
		dataType:'json',
		success:function(json) {
			cluster_load_hide();
			apptrend_graph("bpsup", json.xdate, json.up);
			apptrend_graph("bpsdown", json.xdate, json.down);
			apptrend_graph("bpsflow", json.xdate, json.flow);
		}
	});
}

function apptrend_graph(render, xdate, data)
{
	$("#"+render).show();

	var dom = document.getElementById(render);
	var myChart = echarts.init(dom, 'macarons');

	var title = "";
	switch(render) {
	case "bpsup":
		title = "上行速率趋势图/bps";
		tag = '上行速率';
		break;
	case "bpsdown":
		title = "下行速率趋势图/bps";
		tag = '下行速率';
		break;
	case "bpsflow":
		title = "连接数趋势图/5分钟";
		tag = '连接数';
		break;
	}

	var option = {
		tooltip: {
			trigger: 'axis',
			position: function (pt) {
				return [pt[0], '10%'];
			},
			textStyle: {
				fontSize: 10
			},
			formatter: function(params, ticket, callback) {
				var name = h = "";
				for (i = 0; i < params.length; i++) {
					if (name == "") {
						name = params[i].name;
						h += name;
					}

					 h += '<br/>' + params[i].seriesName + ':' + numberformats(params[i].value);
				}
				return h;
			}
		},
		title: {
			text: title,
			left: '1%',
			top: 10,
			textStyle: {
				fontSize: 12,
				color: '#555'
			}
		},
		xAxis: {
			type: 'category',
			boundaryGap: false,
			splitLine: {
				show: true 
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				},
				formatter:function(value, index) {
					var dt = new Date();
					dt.setTime(value * 1000);
					return dt.getDate()+ '/'+dt.getHours()+':'+dt.getMinutes();
				}
			},
			data: xdate
		},
		grid: {
			left: '5%',
			top: '15%',
			right:'3%'
		},
		legend: {
			show: true,
			top:10,
			right: '0',
			itemWidth:10,
			itemHeight:10,
			textStyle: {
				fontSize: 10,
				color: '#000'
			},
		},
		yAxis: {
			type: 'value',
			name: null,
			nameLocation: 'end',
			splitLine: {
				show: true
			},
			nameTextStyle: {
				fontSize: 10,
				fontWeight: 'bold',
				fontFamily: 'Microsoft YaHei'
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				},
				formatter: function(value, index) {
					return numberformats(value);
				}
			},
			//boundaryGap: [0, '100%']
		},
		series: [] 
	};

	for (i = 0; i < data.length; i++) {
		var item = {name: data[i].name, symbol: "none", type: 'line', stack: '总量', data: data[i].data, lineStyle: {normal: {width: 0}}, areaStyle: {}};
		option.series.push(item);
	}

	myChart.setOption(option);
	myChart.getZr().off('click');
	myChart.getZr().on('click',function (params) {
		var pointInPixel= [params.offsetX, params.offsetY];
	       	if (myChart.containPixel('grid',pointInPixel)) {
			var pointInGrid = myChart.convertFromPixel({seriesIndex:0},pointInPixel);
			var xIndex = pointInGrid[0];
			var op = myChart.getOption();
			var xdate = op.xAxis[0].data[xIndex];
			focus_trend(xdate);
		}
       	});
}

function focus_trend(xdate)
{
	var dt = new Date();
	var x = dt.getFullYear() + '/' + (dt.getMonth() + 1);
	var s = x + '/' + xdate;
	
	var nx = new Date(s).getTime() / 1000;

	var devid = getdevice();
	var linkid = $("#linkid").val();
	var appid = -1;

	var start = $("#start").val();
	var shour = $("#start_hour").val();
	var end = $("#end").val();
	var ehour = $("#end_hour").val();

	var dt = new Date();
	var starttime = start + ' '+shour+':0:0';
	var endtime = end + ' '+ehour+':0:0';

	ShowWindow("focus_trend.php?devid="+devid+"&linkid="+linkid+"&appid="+appid+"&starttime="+starttime+"&endtime="+endtime+"&focus_time="+xdate, "", 600, 600);
}

function showapptree()
{
	if ($('#showapptree_win').length > 0){
		$('#showapptree_win').show();
		$('#showapptree_win').css('z-index', config.zindex++);
		return false;
	}

	$("<div id='showapptree_win'></div>").appendTo("body");

	$('#showapptree_win').load('treepanel.php', function(){
		setWinpos("showapptree_win", 400, 600, "showapptree_con");

		$('#showapptree_win').css('z-index', config.zindex++);

		createtree();

		$("#checkapp").focus();
	});
}

var trees;
function ajaxcheckapp()
{
	var appid = $("#checkapp").val();

	if (appid == ""){
		$("#checklist").html("");
		return false;
	}

	$.post("checkapp.php", {appid:appid}, function(data){
		var res, r, hl = "";
		eval("res="+data);

		for (var i = 0; i < res.result.length; i++){
			r = res.result[i];
			hl += "&nbsp;&nbsp;<a href='javascript:appselect("+r.id+", \""+r.name+"\", \""+r.cname+"\")'>"+r.cname+"</a><br>";
		}

		$("#checklist").html(hl);
	});
}

function appselect(appid, name, cname)
{
	$("#hidappid").val(appid);
	$("#appcname").val(cname);
	$('#showapptree_win').hide();
}

</script>
</head>

<body>
<div class="outer">
	<div class="check-form">
		<ul>
			<li>
				<?php
				echo getdevice();
				?>
			</li>
			<li>
				<label>协议</label>
				<input type="text" id="appcname" value="任意" style="width:100px" readonly />
				<input type="hidden" value="-1" id="hidappid" />
				<input type="button" value="选择协议" onclick="showapptree()" />
			</li>
			<li>
				<label>数据链路</label>
				<select id="linkid" style="width:120px">
					<option value="-1">任意链路</option>
					<option value="1">网桥1</option><option value="2">网桥2</option>
					<option value="3">网桥3</option><option value="4">网桥4</option>
					<option value="6">虚拟链路1</option><option value="7">虚拟链路2</option>
					<option value="8">虚拟链路3</option><option value="9">虚拟链路4</option>
				</select>
			</li>
			<li>
				<label>起始时间</label>
				<?php
				$t = strtotime("now") - 86400;
				?>
				<input type="text" name="start" id="start" style="width:70px;" 
				onclick="new Calendar().show(this);" value="<?= date('Y-m-d', $t) ?>" />
				<input type="text" id="start_hour" value="<?= date('H')?>" style="width:30px" />时
			</li>
			<li>
				<label>结束时间</label>
				<input type="text" name="end" id="end" style="width:70px;" 
				onclick="new Calendar().show(this);" value="<?= date('Y-m-d') ?>" />
				<input type="text" id="end_hour" value="<?= date('H')?>" style="width:30px" /> 时
			</li>
			<li>
				<a class="btn-extend-color" onclick="apptrend_data()">查询</a>
				<a class="btn-extend-gray" href="../download.php?filename=trend_down.xls">下行数据导出</a>
			</li>
		</ul>
		<div class="clearfloat"></div>
	</div>
	
	<div id="bpsup" class="addborder" style="margin:5px 0px;height:300px;display:none;overflow:hidden;"></div>
	<div id="bpsdown" class="addborder" style="margin:5px 0px;height:300px;display:none;overflow:hidden"></div>
	<div id="bpsflow" class="addborder" style="margin:5px 0px;height:300px;display:none;overflow:hidden;"></div>
</div>
<script>
showdevicetree();
</script>
</body>
</html>

