<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	echo '<script type="text/javascript">parent.location.href="../index.php";</script>';
	exit;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" content="no-cache">
<title><?=VERSION?></title>
<script type="text/javascript" src="../js/dtree.js" /></script>
<link type="text/css" rel="stylesheet" href="../css/dtree.css" />
<link type="text/css" rel="stylesheet" href="../css/common.css" />
<link rel="stylesheet" href="../css/ui-lightness/jquery-ui-custom.css">
<script type="text/javascript" src="../js/jquery.min.js"></script>
<script type="text/javascript" src="../js/jquery-ui.min.js"></script>
<script type="text/javascript" src="../js/highcharts.js"></script>
<script type="text/javascript" src="../js/map.js"></script>
<script type="text/javascript" src="../js/china-data.js"></script>
<script type="text/javascript" src="../js/Calendar.js"></script>
<script type="text/javascript" src="../js/common.js"></script>
<script type="text/javascript" src="../js/echarts.min.js"></script>
<script type="text/javascript" src="../js/macarons.js"></script>
<script type="text/javascript">
function apptrend()
{
	var devid = getdevice();

	var linkid = $("#linkid").val();
	var cname = $("#appcname").val();
	//var chartype = "appdown";

	var start = $("#start").val();
	var end = $("#end").val();
	var start_hour = $("#start_hour").val();
	var end_hour = $("#end_hour").val();

	var dt = new Date();
	var starttime = start + ' '+start_hour+':0:0';
	var endtime = end + ' '+end_hour+':0:0';

	var appid = $("#hidappid").val();

	cluster_load_show();
	var errname = dt.getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../App/apptrend.php',
		data:{type:"apptrend", devid:devid, linkid:linkid, tmstart:starttime,
		    tmend:endtime, errname:errname, appid:appid, 
			cname: cname},
		type:'post',
		dataType:'json',
		success:function(json) {
			trenddialog(starttime, endtime, json);
			cluster_load_hide();
		}
	});
}

function trenddialog(starttime, endtime, json)
{
	var cname = $("#appcname").val();
	
	$("#trenddialog").dialog({
		width:700,
		height:600,
		title: cname+' 趋势图'
	});
	
	//apptrend_graph("bps", "upbps", starttime, endtime, json);
	//apptrend_graph("flow", "flowbps", starttime, endtime, json);
	//
	apptrend_graph("bpsup", json.xdate, json.up);
	apptrend_graph("bpsdown", json.xdate, json.down);
	apptrend_graph("bpsflow", json.xdate, json.flow);
}

function apptrend_graph(render, xdate, data)
{
	var dom = document.getElementById(render);
	var myChart = echarts.init(dom, 'macarons');

	var title = "";
	switch(render) {
	case "bpsup":
		title = "上行速率趋势图/bps";
		tag = '上行速率';
		break;
	case "bpsdown":
		title = "下行速率趋势图/bps";
		tag = '下行速率';
		break;
	case "bpsflow":
		title = "连接数趋势图/5分钟";
		tag = '连接数';
		break;
	}

	var fontfamily = "微软雅黑";
	var fontsize = 12;

	option = {
		tooltip: {
			trigger: 'axis',
			position: function (pt) {
				return [pt[0], '10%'];
			},
			textStyle: {
				fontSize: 11
			},
			formatter: function(params, ticket, callback) {
				for (i = 0; i < params.length; i++) {
					return params[i].name + '<br/>' + params[i].seriesName + ':' + numberformats(params[i].value);
				}
			}
		},
		title: {
			text: title,
			left: '1%',
			top:0,
			textStyle: {
				fontSize: 14,
				color: '#555'
			}
		},
		xAxis: {
			type: 'category',
			boundaryGap: false,
			splitLine: {
				show: true 
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				}
			},
			data: xdate
		},
		grid: {
			left: '5%',
			top: '15%',
			right:'3%'
		},
		yAxis: {
			type: 'value',
			name: null,
			nameLocation: 'end',
			splitLine: {
				show: true
			},
			nameTextStyle: {
				fontSize: 10,
				fontWeight: 'bold',
				fontFamily: 'Microsoft YaHei'
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				},
				formatter: function(value, index) {
					return numberformats(value);
				}
			},
			boundaryGap: [0, '100%']
		},
		series: [{
			name: tag,
			type:'line',
			smooth:true,
			symbol: 'circle',
			sampling: 'average',
			showSymbol: false,
			lineStyle: {
				normal: {
					width: 1
				}
			},
			itemStyle: {
				//color: 'rgb(155, 127, 14)',
				borderColor: 'rgba(155, 127, 14, 1)',
				borderWidth: 12
			},
			areaStyle: {
			/*
				color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
					offset: 1,
					//color: 'rgba(255, 127, 14, 0.3)'
				}, {
					offset: 0,
					//color: 'rgba(155, 127, 14, 1)'
				}], false),
			 */
			},
			data: data
		}]
	};

	myChart.setOption(option);
}
var page = 1;
var limit = 0;
var gsort = 'total';

function pre() 
{
	page--;
	if (page <= 0)
		page = 1;
	
	appinfo(0);
}

function next()
{
	page++;
	
	appinfo(0);
}

function appinfo(bexport)
{
	var devid = getdevice();
	var linkid = $("#linkid").val();
	var start = $("#start").val();
	var end = $("#end").val();
	var start_hour = $("#start_hour").val();
	var end_hour = $("#end_hour").val();
	var dt = new Date();
	var starttime = start + ' '+start_hour+':0:0';
	var endtime = end + ' '+end_hour+':0:0';
	var appid = $("#hidappid").val();

	cluster_load_show();
	var errname = dt.getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../App/apptop.php',
		data:{devid:devid, linkid:linkid, tmstart:starttime,
			tmend:endtime, errname:errname, appid:appid, 
			page: page, limit: limit, sort: gsort, 
			bexport:bexport},
		type:'post',
		dataType:'json',
		success:function(json) {
			cluster_load_hide();
			if (json.yn && bexport > 0 && json.yn == "yes") {
				window.open("../download.php?filename="+json.str, "_blank");
			}
			else
				appdata_update(json, devid, linkid, starttime, endtime);
		}
	});
}

function appdata_update(data, devid, linkid, starttime, endtime)
{
	var href1;
	var href2;
       	var trbg = '';
	var t1 = 0, t2 = 0, t3 = 0, t4 = 0, t5 = 0;
	
	devid = devid + '';
	var q = /,/g
	devid = devid.replace(q, '-');
	
	var start = (page - 1) * limit;

	var list = document.getElementById("applist-table");
	while (list.rows.length > 1)
		list.deleteRow(1);
	
	for (i = 0; i < data.detail.length; i++){
	       	r = data.detail[i];
		
		trbg = '';
		if (i % 2 == 1)
		       	trbg = 'log-table-tr-toggle-bgcolor-curr';
		
		h1 = 'javascript:appiplist(\''+devid+'\', '+linkid+', '+r.apid+', \''+ r.name+'\', \''+ r.cname+'\', \''+ starttime+'\', \''+ endtime+'\')';

		var cbox = '<input type="checkbox" value="'+r.apid+'" name="selapp" '+
			'up='+r.totalup+' down='+r.totaldown+' total='+(r.totalup+r.totaldown)+' cname="'+r.cname+'" />';
		href1 = '<a href="javascript:trendopen('+r.linkid+', \''+devid+'\', \''+ r.apid+'\', \''+ 
			r.cname+'\', \''+starttime+'\', \''+endtime+'\')">'+ r.cname+'</a>';

		var obj = list.insertRow(-1);

		var pos = 0;
		var cell = obj.insertCell(pos++);
		cell.setAttribute("align", "center");
		cell.innerHTML = start + i + 1;
		cell = obj.insertCell(pos++);
		cell.setAttribute("align", "center");
		cell.innerHTML = cbox;
		cell = obj.insertCell(pos++);
		cell.innerHTML = href1;
		cell = obj.insertCell(pos++);
		cell.setAttribute("align", "right");
		cell.innerHTML = r.flowcont;
		cell = obj.insertCell(pos++);
		cell.setAttribute("align", "right");
		cell.innerHTML = numberformats(r.totalup);
		cell = obj.insertCell(pos++);
		cell.setAttribute("align", "right");
		cell.innerHTML = numberformats(r.totaldown);
		cell = obj.insertCell(pos++);
		cell.setAttribute("align", "right");
		cell.innerHTML = numberformats(r.totalup + r.totaldown);
		cell = obj.insertCell(pos++);
		cell.setAttribute("align", "right");
		cell.innerHTML = numberformats(r.bpsup);
		cell = obj.insertCell(pos++);
		cell.setAttribute("align", "right");
		cell.innerHTML = numberformats(r.bpsdown);
		cell = obj.insertCell(pos++);
		cell.setAttribute("align", "right");
		cell.innerHTML = numberformats(r.bpstotal);

		t1 += r.flowcont;
		t2 += r.totalup;
		t3 += r.totaldown;
		t4 += r.bpsup;
		t5 += r.bpsdown;
	}
	obj = list.insertRow(-1);

	pos = 0;	
	var cell = obj.insertCell(pos++);
	cell.innerHTML = '';
	cell = obj.insertCell(pos++);
	cell.innerHTML = '';
	cell = obj.insertCell(pos++);
	cell.innerHTML = '总计';
	cell = obj.insertCell(pos++);
	cell.innerHTML = t1;
	cell = obj.insertCell(pos++);
	cell.innerHTML = numberformats(t2);
	cell = obj.insertCell(pos++);
	cell.innerHTML = numberformats(t3);
	cell = obj.insertCell(pos++);
	cell.innerHTML = numberformats(t2 + t3);
	cell = obj.insertCell(pos++);
	cell.innerHTML = numberformats(t4);
	cell = obj.insertCell(pos++);
	cell.innerHTML = numberformats(t5);
	cell = obj.insertCell(pos++);
	cell.innerHTML = numberformats(t4 + t5);
}

function titleclick(sort)
{
	gsort = sort;
	appinfo(0);
}

function trendopen(linkid, devid, apid, cname, starttime, endtime)
{
	var w = 900;
	var h = window.screen.height - 150;
	var l = (window.screen.width - w)/2;
	
	devid = devid + '';
	var q = /-/g
	devid = devid.replace(q, ',');
	
	window.open("../App/trendopen.php?devid="+devid+"&linkid="+linkid+
		"&appid="+apid+"&cname="+cname+"&starttime="+starttime+
		"&endtime="+endtime, "_blank", "width="+w+"px, height="+h+"px, left="+l+"px");
}

function showapptree()
{
	if ($('#showapptree_win').length > 0){
		$('#showapptree_win').show();
		$('#showapptree_win').css('z-index', config.zindex++);
		return false;
	}

	$("<div id='showapptree_win'></div>").appendTo("body");

	$('#showapptree_win').load('../user_behavior/treepanel.php', function(){
		setWinpos("showapptree_win", 400, 600, "showapptree_con");

		$('#showapptree_win').css('z-index', config.zindex++);

		createtree();

		$("#checkapp").focus();
	});
}
var trees;
function createtree()
{
	var data;
	var devid;

	trees = new dTree('trees');
	trees.add(0, -1, '选择协议');

	$.ajax({
		url:'../user_behavior/tree.php',
		type:'get',
		dataType:'json',
		success:function(data){
			for (var i = 0; i < data.result.length; i++){
				r = data.result[i];
				cname = decodeURIComponent(r.cname);
				trees.add(r.id, r.parent, r.cname, 
					"javascript:appselect("+r.id+", '"+r.name+"', '"+cname+"')");
			}

			trees.add(1500, 1044, "自定义协议组", "");
			for (var i = 0; i < data.cusgrp.length; i++) {
				r = data.cusgrp[i];
				cname = decodeURIComponent(r.cname);
				trees.add(r.id, r.parent, r.cname, 
						"javascript:appselect("+r.id+", '"+r.name+"', '"+cname+"')");
			}

			var tree = trees.toString();
			$("#treelist").html(tree);
			data.result.length = 0;
		}
	})
}

function ajaxcheckapp()
{
	var appid = $("#checkapp").val();

	if (appid == ""){
		$("#checklist").html("");
		return false;
	}

	$.post("../user_behavior/checkapp.php", {appid:appid}, function(data){
		var res, r, hl = "";
		eval("res="+data);

		for (var i = 0; i < res.result.length; i++){
			r = res.result[i];
			hl += "&nbsp;&nbsp;<a href='javascript:appselect("+r.id+", \""+
			r.name+"\", \""+r.cname+"\")'>"+r.cname+"</a><br>";
		}

		$("#checklist").html(hl);
	});
}

function appselect(appid, name, cname)
{
	$("#hidappid").val(appid);
	$("#hidname").val(name);
	$("#appcname").val(cname);

	$('#showapptree_win').hide();
}

function appiplist(devid, linkid, appid, name, cname, starttime, endtime)
{
	var w = 600;
	var h = window.screen.height - 150;
	var l = (window.screen.width - w)/2;
	
	window.open("../App/apptoip.php?devid="+devid+"&linkid="+linkid+
		"&name="+name+"&cname="+cname+"&starttime="+starttime+
		"&endtime="+endtime+"&appid="+appid, "_blank", "width="+w
		+"px, height="+h+"px, left="+l+"px");
}

function appgroup_pie_chart(chartype, render, data)
{
	$("#"+render).show();
	
	var title = "下行流量分布图";
	if (chartype == "up")
		title = "上行流量分布图";
	else if (chartype == "total")
		title = "总流量分布图";

	var option = {
	chart: {
	    renderTo: render,
	    defaultSeriesType: 'pie',
			//backgroundColor: '#f5f5f5',
			//borderWidth: 1,
			borderColor:'#D3DCEB',
			borderRadius:4
	},
	title: {
	    text: title,
	style:{font: '微软雅黑', fontSize:'12px', color:'#666', fontWeight:'bold'}
	},
	subtitle: {
	    text: null
	},
	xAxis: {
	    categories: [],
	    title: {
		text: null
	    },
	    labels:{
		rotation:-45,
		align:'right',
		style:{font:'normal 11px Verdana, sans-serif', color:'#000000'}
	    }
	},
	yAxis: {
	    min: 0,
	    title: {
		text: 'byte'
	    }
	},
	tooltip: {
	    formatter: function() {
		return ''+
		    this.point.name +': '+ numberformats(this.y);
	    }
	},
	plotOptions: {
	    pie: {
		size:'50%',
		allowPointSelect: true,
		cursor: 'pointer',
		dataLabels: {
		    enabled: true,
			style:{fontSize:'9px', fontWeight:'normal', width:'70px', color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'},
		    formatter: function() {
			return this.point.name +': '+ Highcharts.numberFormat(this.point.percentage, 1) + '%';
		    }
		},
				point:{
		    events:{
			click:function(){
			    groupinfo(this.appid, '', cname, starttime, endtime);
			}
		    }},
	    }
	},
	legend: {
	    enabled:false
	},
	credits: {
	    enabled: false
	},
	series: [{type:'pie', data:[]}]
	};
/*
	for (var i = 0; i < json.yup.length; i++){
		if (chartype == "appflow")
			option.series[0].data.push({name:json.x[i], y:json.yflow[i], appid:json.result[i].apid});
	else option.series[0].data.push({name:json.x[i], y:json.ytotal[i], appid:json.result[i].apid});
	}
	*/
	option.series[0].data = data;
	var chart = new Highcharts.Chart(option);
}

function selectappforpie()
{
	var num = 0;
	var apparrup = [];
	var apparrdown = [];
	var apparrtotal = [];
	var otherup = otherdown = othertotal = 0;
	//alert(dataforpiejson.result.length);
	
	$("[name='selapp']").each(function(){
		if ($(this).attr("checked")) {
			apparrup.push({y: parseInt($(this).attr("up")), name: $(this).attr("cname")});
			apparrdown.push({y: parseInt($(this).attr("down")), name: $(this).attr("cname")});
			apparrtotal.push({y: parseInt($(this).attr("total")), name: $(this).attr("cname")});
			num++;
		}else {
			otherup += parseInt($(this).attr("up"));
			otherdown += parseInt($(this).attr("down"));
			othertotal += parseInt($(this).attr("total"));
		}
	});

	if (num == 0) {
		alert("请选择协议");
		return false;
	}

	if (!$("[name='dontinput']").eq(0).attr("checked")) {
		apparrup.push({name:'other', y: otherup});
		apparrdown.push({name:'other', y: otherdown});
		apparrtotal.push({name:'other', y: othertotal});
	}
	
	appgroup_pie_chart("up", "pieup", apparrup);
	appgroup_pie_chart("down", "piedown", apparrdown);
	appgroup_pie_chart("total", "pietotal", apparrtotal);
}

</script>
</head>
<body>
<div class="outer">
	<div class="check-form">
		<ul>
			<li class="">
				<?php
				echo getdevice();
				?>
			</li>
			<li class="">
				<label>协议</label>
				<input type="text" id="appcname" value="所有协议" style="width:70px" readonly />
				<input type="hidden" value="-1" id="hidappid" />
				<input type="hidden" value="any" id="hidname" />
				<input type="button" value="选择协议" onclick="showapptree()" />
			</li>
			<li class="">
				<label>数据链路</label>
				<select id="linkid" style="width:70px">
					<option value="-1">任意链路</option>
					<option value="1">网桥1</option><option value="2">网桥2</option>
					<option value="3">网桥3</option><option value="4">网桥4</option>
					<option value="6">虚拟链路1</option><option value="7">虚拟链路2</option>
					<option value="8">虚拟链路3</option><option value="9">虚拟链路4</option>
				</select>
			</li>
			<li class="">
				<label>起始时间</label>
				<?php
				$t = strtotime("now") - 86400;
				?>
				<input type="text" name="start" id="start" style="width:80px;" 
				onclick="new Calendar().show(this);" value="<?= date('Y-m-d', $t) ?>" />
				<input type="text" id="start_hour" value="<?= date('H')?>" style="width:30px" />时
			</li>
			<li class="">
				<label>结束时间</label>
				<input type="text" name="end" id="end" style="width:80px;" 
				onclick="new Calendar().show(this);" value="<?= date('Y-m-d') ?>" />
				<input type="text" id="end_hour" value="<?= date('H')?>" style="width:30px" /> 时
			</li>
			<li class="">
				<div class="layui-btn-container">
					<button class="layui-btn layui-btn-normal layui-btn-xs" onclick="appinfo(0)">
						<icon class="layui-icon layui-icon-search"></icon>查询
					</button>
					<button class="layui-btn layui-btn-normal layui-btn-xs" onclick="apptrend()">
						<icon class="layui-icon layui-icon-chart"></icon>趋势图</button>
					</button>
					<button class="layui-btn layui-btn-normal layui-btn-xs" onclick="selectappforpie()">选择协议分布图</button>
				</div>
			</li>
			<li class="">
				<input type="checkbox" value="" name="dontinput" /> 剩余的协议不参与统计
			</li>
			<li class="">
				<div class="layui-btn-group">
					<button class="layui-btn layui-btn-normal layui-btn-xs" id="export-excel">
						<icon class="layui-icon layui-icon-export"></icon>EXCEL
					</button>
					<button class="layui-btn layui-btn-normal layui-btn-xs" id="export-txt">
						<icon class="layui-icon layui-icon-export"></icon>TXT
					</button>
					<button class="layui-btn layui-btn-normal layui-btn-xs" id="export-csv">
						<icon class="layui-icon layui-icon-export"></icon>CSV
					</button>
				</div>
			</li>
		</ul>
		<div class="clearfloat"></div>
	</div>
	
	<div class="topapp-list-table addborder">
		<div id="pieup" style="float:left; width:33%; height:300px; display:none;"></div>
		<div id="piedown" style="float:left; width:33%; height:300px; display:none;"></div>
		<div id="pietotal" style="float:left; width:33%; height:300px; display:none;"></div>
		<table style="width:100%;border-collapse:collapse;" cellspacing=0 cellpadding=0 id="applist-table">
			<tr>
			<th class="txt-center" width="50px">序号</th>
			<th class="txt-center" width="50px"></th>
			<th class="txt-left">协议名称</th>
			<th class="txt-right"><a href="javascript:titleclick('flow')">连接数</a></th>
			<th class="txt-right"><a href="javascript:titleclick('up')">上行流量(Byte)</a></th>
			<th class="txt-right"><a href="javascript:titleclick('down')">下行流量(Byte)</a></th>
			<th class="txt-right"><a href="javascript:titleclick('total')">总流量(Byte)</a></th>
			<th class="txt-right"><a href="javascript:titleclick('up')">上行速率(bps)</a></th>
			<th class="txt-right"><a href="javascript:titleclick('down')">下行速率(bps)</a></th>
			<th class="txt-right"><a href="javascript:titleclick('total')">总速率(bps)</a></th>
			</tr>
		</table>
	</div>
	<div id="showip" style="float:left;margin:5px 5px;width:100%;height:30px;text-align:right;font-size:12px;display:none;"></div>
	
	<div id="trenddialog" style="display:none;">
		<div id="bpsup" style="float:left;margin:5px 5px;width:100%;height:300px"></div>
		<div id="bpsdown" style="float:left;margin:5px 5px;width:100%;height:300px"></div>
		<div id="bpsflow" style="float:left;margin:5px 5px;width:100%;height:300px"></div>
	</div>
</div>
<script type="text/javascript" src="../layui/layui.js"></script>
<script type="text/javascript">
Highcharts.setOptions({ global: { useUTC: false } });
showdevicetree();
layui.use('element', function(){
	var element = layui.element;

	$("#export-excel").click(function(){
		appinfo(1);
	});
	$("#export-txt").click(function(){
		appinfo(2);
	});
	$("#export-csv").click(function(){
		appinfo(3);
	});

})
</script>
</body>
</html>
