<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	echo '<script type="text/javascript">parent.location.href="../index.php";</script>';
	exit;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" content="no-cache">
<title><?=VERSION?></title>
<link type="text/css" rel="stylesheet" href="../css/common.css" />
<link rel="stylesheet" href="../css/ui-lightness/jquery-ui-custom.css">
<script type="text/javascript" src="../js/jquery.min.js"></script>
<script type="text/javascript" src="../js/jquery-ui.min.js"></script>
<script type="text/javascript" src="../js/common.js"></script>
<script type="text/javascript" src="../js/Calendar.js"></script>
<script type="text/javascript" src="../js/echarts.min.js"></script>
<script type="text/javascript" src="../js/macarons.js"></script>
</head>
<body>
<script type="text/javascript">
function piechart(chartype, render, json)
{
    	var title = "自定义协议连接数分布图";
    	if (chartype == "bytes")
        	title = "自定义协议流量分布图";

	var data = [], x = [];
	var len = json.name.length;
	for (i = 0; i < len; i++) {
		x.push(json.name[i]);
		if (chartype == "bytes")
			data.push({name: json.name[i], value: json.total[i], appid: json.rows[i].appid});
		else
			data.push({name: json.name[i], value: json.flow[i], appid: json.rows[i].appid});
	}

	option = {
    		title: {
			text: title, 
			left: 'center',
			textStyle: {
				fontSize: 14,
				color: '#555'
			}
    		},
    		tooltip : {
        		trigger: 'item',
			formatter: function(p) {
				return p.name + ': ' + numberformats(p.value);
			},
			textStyle: {
				fontSize: 11
			},
    		},
		grid: {
			right: 30,
		},
    		legend: {
			show: false,
        		orient: 'vertical',
        		right: 'right',
			top: '15%',
			textStyle: {
				fontSize: '10'
			},
        		data: x
    		},
    		series : [{
            		type: 'pie',
            		radius : '55%',
            		center: ['50%', '50%'],
            		data: data,
			label: {
				show: true 
			},
			labelLine: {
				normal: {
					smooth: true,
					show: true 
				}
			},
            		itemStyle: {
                		emphasis: {
                    			shadowBlur: 10,
                    			shadowOffsetX: 0,
                    			shadowColor: 'rgba(0, 0, 0, 0.5)'
                		}
            		}
        	}]
	};

	var dom = document.getElementById(render);
	var myChart = echarts.init(dom, 'macarons');
	myChart.setOption(option);

	myChart.on('click', function (params) {
		console.log(params);
		apptrend_popup(params.data.appid, params.name);
	});
}

function column_graph(json)
{
	var dom = document.getElementById("appgroupcolumn");
	var myChart = echarts.init(dom, 'macarons');

	var maxflow = 0;
	for (i = 0; i < json.flow.length; i++) {
		if (json.flow[i] > maxflow)
			maxflow = json.flow[i];
	}

	var yup = [], ydown = [], yflow = [], x = [];
	var len = json.flow.length;
	for (i = 0; i < len; i++) {
		x.push(json.name[i]);
		yup.push({appid: json.rows[i].appid, value: json.up[i]});
		ydown.push({appid: json.rows[i].appid, value: json.down[i]});
		yflow.push({appid: json.rows[i].appid, value: json.flow[i]});
	}

	option = {
		backgroundColor: "#fff",
		title: {
			text: '自定义协议流量与连接数关系图',
			left: 10,
			textStyle: {
				fontSize: 14, 
				color: '#555'
			}
		},
		tooltip: {
			trigger: "axis",
			textStyle: {
				fontSize: 11
			},
			axisPointer: {
				type: "shadow",
				textStyle: {
					color: "#fff",
					fontSize: 11
				}
			},
			formatter: function(params, ticket, callback) {
				var htm = params[0].name;
				for (i = 0; i < params.length; i++) {
					htm += '<br/>' + params[i].seriesName + ': ' + numberformats(params[i].value);
				}
				return htm;
			}
		},
		grid: {
			borderWidth: 0,
			top: 50,
			left:50,
			bottom: 50,
			textStyle: {
				color: "#fff"
			}
		},
		legend: {
			show: false,
			x: '4%',
			top: '11%',
			textStyle: {
				color: '#90979c',
			},
			data: ['上行流量', '下行流量', '连接数']
		},
		calculable: false,
		xAxis: [{
			type: "category",
			axisLine: {
				lineStyle: {
				}
			},
			splitLine: {
				show: true
			},
			axisTick: {
				show: false
			},
			splitArea: {
				show: false
			},
			axisLabel: {
				interval: 0,
				rotate: 40,
				color: '#000',
				textStyle: {
					fontSize: '10'
				}
			},
			data: x,
		}],
		yAxis: [{
			type: "value",
			name: '流量/byte',
			splitLine: {
				show: true
			},
			axisLine: {
				lineStyle: {
					color: '#90979c'
				}
			},
			axisTick: {
				show: false
			},
			axisLabel: {
				interval: 0,
				color: '#000',
				textStyle: {
					fontSize: '10'
				},
				formatter: function(value, index) {
					return numberformats(value);
				}
			},
			splitArea: {
				show: false
			},
			position: 'left',
			min: 0,
		}, {
            		type: 'value',
            		scale: true,
			name: '连接数',
            		boundaryGap: [0.2, 0.2],
			min: 0,
			max: maxflow,
			splitLine: {
				show: false,
			},
			axisLabel: {
				interval: 0,
				color: '#000',
				textStyle: {
					fontSize: '10'
				},
				formatter: function(value, index) {
					return numberformats(value);
				}
			},
			position: 'right',
        	}],
		series: [
		{
			name: "连接数",
			type: "line",
			stack: "总量",
			symbolSize:10,
			yAxisIndex: 1,
		       	symbol:'circle',
			smooth: true,
			itemStyle: {
				normal: {
					//color: 'rgb(155, 127, 14)',
					label: {
						show: false,
						textStyle: {
							color: "#fff"
						},
						position: "insideTop",
						formatter: function(p) {
							return numberformats(p.value)
						}
					}
				}
			},
			data: yflow,
		},
		{
			name: "上行流量",
			type: "bar",
			stack: "总量",
			barMaxWidth: 35,
			barGap: "10%",
			itemStyle: {
				normal: {
					//color: "rgba(255,144,128,1)",
					label: {
						show: false,
						textStyle: {
							color: "#000"
						},
						position: "insideTop",
						formatter: function(p) {
							console.log(p);
							return numberformats(p.value)
						}
					}
				}
			},
			data: yup,
		},
		{
			name: "下行流量",
			type: "bar",
			stack: "总量",
			barMaxWidth: 35,
			barGap: "10%",
			itemStyle: {
				normal: {
					//color: "rgba(0,191,183,1)",
					label: {
						show: false,
						textStyle: {
							color: "#fff"
						},
						position: "insideTop",
						formatter: function(p) {
							return numberformats(p.value)
						}
					}
				}
			},
			data: ydown,
		}]
	}
	
	myChart.setOption(option);

	myChart.on('click', function (params) {
		console.log(params);
		apptrend_popup(params.data.appid, params.name);
	});
}

function trend_graph(render, xdate, data)
{
	var dom = document.getElementById(render);
	var myChart = echarts.init(dom, 'macarons');

	var title = "";
	switch(render) {
	case "bpsup":
		title = "上行速率趋势图/bps";
		tag = '上行速率';
		break;
	case "bpsdown":
		title = "下行速率趋势图/bps";
		tag = '下行速率';
		break;
	case "bpsflow":
		title = "连接数趋势图/5分钟";
		tag = '连接数';
		break;
	}

	var fontfamily = "微软雅黑";
	var fontsize = 12;

	option = {
		tooltip: {
			trigger: 'axis',
			position: function (pt) {
				return [pt[0], '10%'];
			},
			textStyle: {
				fontSize: 11
			},
			formatter: function(params, ticket, callback) {
				for (i = 0; i < params.length; i++) {
					return params[i].name + '<br/>' + params[i].seriesName + ':' + numberformats(params[i].value);
				}
			}
		},
		title: {
			text: title,
			left: '1%',
			top:0,
			textStyle: {
				fontSize: 14,
				color: '#555'
			}
		},
		xAxis: {
			type: 'category',
			boundaryGap: false,
			splitLine: {
				show: true 
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				}
			},
			data: xdate
		},
		grid: {
			left: '5%',
			top: '15%',
			right:'3%'
		},
		yAxis: {
			type: 'value',
			name: null,
			nameLocation: 'end',
			splitLine: {
				show: true
			},
			nameTextStyle: {
				fontSize: 10,
				fontWeight: 'bold',
				fontFamily: 'Microsoft YaHei'
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				},
				formatter: function(value, index) {
					return numberformats(value);
				}
			},
		},
		series: [{
			name: tag,
			type:'line',
			smooth:true,
			symbol: 'circle',
			sampling: 'average',
			showSymbol: false,
			lineStyle: {
				normal: {
					width: 1
				}
			},
			itemStyle: {
				//color: 'rgb(155, 127, 14)',
				borderColor: 'rgba(155, 127, 14, 1)',
				borderWidth: 12
			},
			areaStyle: {
			/*
				color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
					offset: 1,
					//color: 'rgba(255, 127, 14, 0.3)'
				}, {
					offset: 0,
					//color: 'rgba(155, 127, 14, 1)'
				}], false),
			 */
			},
			data: data
		}]
	};

	myChart.setOption(option);
}

function cusaxp_top()
{
	var start = $("#start").val();
	var end = $("#end").val();
	var dt = new Date();
	var starthour = $("#starthour").val();
	var endhour = $("#endhour").val();
	var starttime = start + ' '+starthour+':0:0';
	var endtime = end + ' '+endhour+':59:59';
	
	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../App/ajax_app_custom.php',
		data:{action: 'top', starttime:starttime, endtime:endtime, errname:errname},
		type:'post',
		dataType:'json',
		success:function(json) {
			cluster_load_hide();
			column_graph(json);
			piechart("bytes", "piebytes", json);
			piechart("flow", "pieflow", json);
			
			trend_graph("bpsdown", json.cate, json.avg_down);
			trend_graph("bpsup", json.cate, json.avg_up);
			trend_graph("bpsflow", json.cate, json.avg_flow);
		}
	});
}

function apptrend_popup(appid, cname)
{
	var w = 900;
	var h = window.screen.height - 150;
	var l = (window.screen.width - w)/2;
	
	var start = $("#start").val();
	var end = $("#end").val();
	var dt = new Date();
	var starthour = $("#starthour").val();
	var endhour = $("#endhour").val();
	var starttime = start + ' '+starthour+':0:0';
	var endtime = end + ' '+endhour+':59:59';

	window.open("cusaxp_trendopen.php?appid="+appid+"&cname="+cname+"&starttime="+starttime+
		"&endtime="+endtime, "_blank", "width="+w+"px, height="+h+"px, left="+l+"px");
}

</script>
<div class="outer">
	<div class="als-nav-header">
		<ul>
			<li class="active"><a href="customaxpflow.php">流量概况</a></li>
			<li class=""><a href="customaxp_top.php">Top协议</a></li>
		</ul>
	</div>
	<div class="check-form">
		<ul>
			<li>
				<label>起始时间</label>
				<?php
				$t = strtotime("now") - 86400;
				?>
				<input type="text" name="start" id="start" style="width:80px;" 
				onclick="new Calendar().show(this);" value="<?= date('Y-m-d', $t) ?>" />
				<input type="text" name="starthour" id="starthour" style="width:30px;" value="<?= date('H', $t) ?>" />时
			</li>
			<li>
				<label>结束时间</label>
				<input type="text" name="end" id="end" style="width:80px;" 
				onclick="new Calendar().show(this);" value="<?= date('Y-m-d') ?>" />
				<input type="text" name="endhour" id="endhour" style="width:30px;" value="<?= date('H', $t) ?>" />时
			</li>
			<li>
				<a class="btn-extend-color " onclick="cusaxp_top()">查询</a>
			</li>
		</ul>
		<div class="clearfloat"></div>
	</div>

	<div style="float:left;width:38%;margin-top:15px;">
		<div id="appgroupcolumn" style="width:100%;height:300px;margin-top:10px;"></div>
	</div>
	<div style="float:left;width:30%;margin-top:15px; margin-left:5px;">
		<div id="piebytes" style="width:100%;height:300px;margin-top:10px;"></div>
	</div>
	<div style="float:left;width:30%;margin-top:15px; margin-left:5px;">
		<div id="pieflow" style="width:100%;height:300px;margin-top:10px;"></div>
	</div>
	<div style="clear:both;"></div>
	<div style="margin-top:40px;">
		<div id="bpsdown" style="position:relative;height:300px;margin-top:10px;overflow:hidden;"></div>
	</div>
	<div style="margin-top:15px;">
		<div id="bpsup" style="position:relative;height:300px;margin-top:10px;overflow:hidden;"></div>
	</div>
	<div style="margin-top:15px;">
		<div id="bpsflow" style="height:300px;margin-top:10px;overflow:hidden;"></div>
	</div>
</div>
<script>
checkaxptable();
cusaxp_top();
</script>
</body>
</html>

