<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	echo '<script type="text/javascript">parent.location.href="../index.php";</script>';
	exit;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" content="no-cache">
<title><?=VERSION?></title>
<link type="text/css" rel="stylesheet" href="../css/common.css" />
<link type="text/css" rel="stylesheet" href="../css/dtree.css" />
<script type="text/javascript" src="../js/dtree.js"></script>
<script type="text/javascript" src="../js/jquery.min.js"></script>
<script type="text/javascript" src="../js/common.js"></script>
<script type="text/javascript" src="../js/Calendar.js"></script>
<script type="text/javascript" src="../js/echarts.min.js"></script>
<script type="text/javascript" src="../js/macarons.js"></script>
<script type="text/javascript" src="../layui/layui.js"></script>
</head>
<body>
<?php
$free = getversion();
echo '<input type="hidden" value="'.$free.'" id="logversion" />';
?>
<script type="text/javascript">
function piechart(chartype, render, json, starttime, endtime)
{
    	var title = "连接数分布图";
    	if (chartype == "apptotal")
        	title = "流量分布图";

	var data = [];
	var len = json.result.length;
	for (i = 0; i < len; i++) {
		if (chartype == "apptotal")
			data.push({
				name: json.result[i].cname, 
				value: json.result[i].total, 
				appid: json.result[i].apid, 
				label:{show:true}, labelLine:{show:true}
			});
		else
			data.push({
				name: json.result[i].cname, 
				value: json.result[i].flow, 
				appid: json.result[i].apid, 
				label:{show:true}, 
				labelLine:{show:true}
			});
	}

	option = {
    		title: {
			text: title, 
			left: 'center',
			textStyle: {
				fontSize: 12,
				color: '#555'
			}
    		},
    		tooltip : {
        		trigger: 'item',
			formatter: function(p) {
				var v = '连接数：' + p.value;
				if (chartype == "apptotal")
					v = '流量：' + numberformats(p.value) + 'B';
				return p.name + '<br/>' + v + '<br/>占比：'+p.percent + '%';
			},
			textStyle: {
				fontSize: 10
			},
    		},
		grid: {
			right: 30,
		},
    		legend: {
			show: false,
        		orient: 'vertical',
        		right: 'right',
			top: '15%',
			textStyle: {
				fontSize: '10'
			},
    		},
    		series : [{
            		name: '访问来源',
            		type: 'pie',
            		radius : '55%',
            		center: ['50%', '60%'],
            		data: data,
			label: {
				//show: true,
				fontSize: '10',
				formatter: function(params, ticket, callback) {
					return params.name + '('+params.percent+'%)'
				}
			},
			labelLine: {
				normal: {
					smooth: true,
					//show: true 
				}
			},
            		itemStyle: {
                		emphasis: {
                    			shadowBlur: 10,
                    			shadowOffsetX: 0,
                    			shadowColor: 'rgba(0, 0, 0, 0.5)'
                		}
            		}
        	}]
	};

	var stat = $("[name='zero_label_state']").eq(0).attr("checked");
	if (typeof stat == "undefined" || stat == "") {
		var opt = option.series[0];
		lineHide(opt);
	}

	var dom = document.getElementById(render);
	myChart = echarts.init(dom, 'macarons');
	myChart.setOption(option, true);
	myChart.on('click', function (params) {
		groupinfo(params.data.appid, params.name);
	});

}

function appgroupcolumn_graph(json, starttime, endtime)
{
	var dom = document.getElementById("appgroupcolumn");
	var myChart = echarts.init(dom, 'macarons');

	var maxflow = 0;
	for (i = 0; i < json.result.length; i++) {
		if (json.result[i].flow > maxflow)
			maxflow = json.result[i].flow;
	}

	var yup = [], ydown = [], yflow = [], x = [];
	var len = json.result.length;
	for (i = 0; i < len; i++) {
		x.push(json.result[i].cname);
		yup.push({appid: json.result[i].apid, value: json.result[i].up});
		ydown.push({appid: json.result[i].apid, value: json.result[i].down});
		yflow.push({appid: json.result[i].apid, value: json.result[i].flow});
	}

	option = {
		backgroundColor: "#fff",
		title: {
			text: '协议组流量',
			left: 10,
			textStyle: {
				fontSize: 12, 
				color: '#555'
			}
		},
		tooltip: {
			trigger: "axis",
			textStyle: {
				fontSize: 11
			},
			axisPointer: {
				type: "shadow",
				textStyle: {
					color: "#fff",
					fontSize: 11
				}
			},
			formatter: function(params, ticket, callback) {
				var htm = params[0].name;
				for (i = 0; i < params.length; i++) {
					htm += '<br/>' + params[i].seriesName + ': ' + numberformats(params[i].value);
				}
				return htm;
			}
		},
		grid: {
			borderWidth: 0,
			top: 50,
			left:50,
			bottom: 50,
			textStyle: {
				color: "#fff"
			}
		},
		legend: {
			show: true,
			right: '0',
			itemWidth:10,
			itemHeight:10,
			textStyle: {
				fontSize: 10,
				color: '#000'
			},
			data: ['上行流量', '下行流量', '连接数']
		},
		calculable: false,
		xAxis: [{
			type: "category",
			axisLine: {
				lineStyle: {
				}
			},
			splitLine: {
				show: true
			},
			axisTick: {
				show: false
			},
			splitArea: {
				show: false
			},
			axisLabel: {
				interval: 0,
				rotate: 40,
				color: '#000',
				textStyle: {
					fontSize: '10'
				}
			},
			data: x,
		}],
		yAxis: [{
			type: "value",
			splitLine: {
				show: true
			},
			axisLine: {
				lineStyle: {
					color: '#90979c'
				}
			},
			axisTick: {
				show: false
			},
			axisLabel: {
				interval: 0,
				color: '#000',
				textStyle: {
					fontSize: '10'
				},
				formatter: function(value, index) {
					return numberformats(value);
				}
			},
			splitArea: {
				show: false
			},
			position: 'left',
			min: 0,
		}, {
            		type: 'value',
            		scale: true,
            		boundaryGap: [0.2, 0.2],
			min: 0,
			max: maxflow,
			splitLine: {
				show: false,
			},
			axisLabel: {
				interval: 0,
				color: '#000',
				textStyle: {
					fontSize: '10'
				},
				formatter: function(value, index) {
					return numberformats(value);
				}
			},
			position: 'right',
        	}],
		series: [
		{
			name: "连接数",
			type: "line",
			stack: "总量",
			symbolSize:10,
			yAxisIndex: 1,
		       	symbol:'circle',
			smooth: true,
			itemStyle: {
				normal: {
					//color: 'rgb(155, 127, 14)',
					label: {
						show: false,
						textStyle: {
							color: "#fff"
						},
						position: "insideTop",
						formatter: function(p) {
							return numberformats(p.value)
						}
					}
				}
			},
			data: yflow,
		},
		{
			name: "上行流量",
			type: "bar",
			stack: "总量",
			barMaxWidth: 35,
			barGap: "10%",
			itemStyle: {
				normal: {
					//color: "rgba(255,144,128,1)",
					label: {
						show: false,
						textStyle: {
							color: "#000"
						},
						position: "insideTop",
						formatter: function(p) {
							return numberformats(p.value)
						}
					}
				}
			},
			data: yup,
		},
		{
			name: "下行流量",
			type: "bar",
			stack: "总量",
			barMaxWidth: 35,
			barGap: "10%",
			itemStyle: {
				normal: {
					//color: "rgba(0,191,183,1)",
					label: {
						show: false,
						textStyle: {
							color: "#fff"
						},
						position: "insideTop",
						formatter: function(p) {
							return numberformats(p.value)
						}
					}
				}
			},
			data: ydown,
		}]
	}
	myChart.setOption(option, true);
	myChart.on('click', function (params) {
		groupinfo(params.data.appid, params.name);
	});
}

function trendopen(apid, cname, starttime, endtime)
{
	var w = 900;
	var h = window.screen.height - 150;
	var l = (window.screen.width - w)/2;
	
	var devid = getdevice();
	var linkid = $("#linkid").val();
	
	window.open("../App/trendopen.php?devid="+devid+"&linkid="+linkid+
		"&appid="+apid+"&cname="+cname+"&starttime="+starttime+
		"&endtime="+endtime, "_blank", "width="+w+"px, height="+h+"px, left="+l+"px");
}

function groupinfo(appid, cname, starttime, endtime)
{
	var devid = getdevice();

	var datetime = $("#datetime").val();
	
	if (datetime == "") {
		layer.msg("请选择要查询的时间范围.");
		return false;
	}
	var d = datetime.split('~');
	starttime = d[0];
	endtime = d[1];

	var linkid = $("#linkid").val();

	var left = (window.screen.width - 800) / 2;
	var height = window.screen.height - 150;
	
	window.open("groupinfo.php?starttime="+
		starttime+"&endtime="+endtime+"&cname="+cname+
		"&appid="+appid+"&devid="+devid+"&linkid="+linkid, 
		"_blank", "width=700px, height="+height+", left="+left);
}

var gsort = '';
function titleclick(sort)
{
	gsort = sort;
	appgroup_pie();
}

function appgroup_pie()
{
	var devid = getdevice();
	var linkid = $("#linkid").val();
	// var appid = -1;
	var appid = $("#hidappid").val();

	var datetime = $("#datetime").val();
	if (datetime == "") {
		layer.msg("请选择要查询的时间范围.");
		return false;
	}
	var d = datetime.split('~');
	starttime = d[0];
	endtime = d[1];

	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../App/apppie.php',
		data:{type:'checkcustom', devid:devid, linkid:linkid, 
			tmstart:starttime, tmend:endtime, sort:gsort, 
			appid:appid, errname:errname},
		type:'post',
		dataType:'json',
		success:function(json){
			cluster_load_hide();

			piechart("appflow", "appgrouppie_up", json, starttime, endtime);
			piechart("apptotal", "appgrouppie_down", json, starttime, endtime);
			appgroupcolumn_graph(json, starttime, endtime);
			
			drawtrend();
		}
	});
}

function defpro_appgroup()
{
//	if ($("#gol_user").val() != "admin" && $("#gol_usertype").val() == "") {
//		showerror("请点击页面查询按钮查询数据.");
//		return false;
//	}

	var start = $("#start").val();
	var end = $("#end").val();
	var dt = new Date();
	var starttime = start + ' '+dt.getHours()+':'+dt.getMinutes()+':0';
	var endtime = end + ' '+dt.getHours()+':'+dt.getMinutes()+':0';

	$.ajax({
		url:'../App/apppie.php',
		data:{type: 'defpro_appgroup'},
		type:'post',
		dataType:'json',
		success:function(json){
			piechart("appflow", "appgrouppie_up", json, starttime, endtime);
			piechart("apptotal", "appgrouppie_down", json, starttime, endtime);
			appgroupcolumn_graph(json, starttime, endtime);
			cluster_load_hide();
			defpro_apptrend();
		}
	});
}

function defpro_apptrend()
{
	var start = $("#start").val();
	var end = $("#end").val();
	var dt = new Date();
	var starttime = start + ' '+dt.getHours()+':'+dt.getMinutes()+':0';
	var endtime = end + ' '+dt.getHours()+':'+dt.getMinutes()+':0';

	$.ajax({
		url:'../App/ajax_group_stat.php',
		data:{action: 'default'},
		type:'post',
		dataType:'json',
		success:function(json){
			apptrend_graph("bpsup", json.xdate, json.up);
			apptrend_graph("bpsdown", json.xdate, json.down);
			apptrend_graph("bpsflow", json.xdate, json.flow);

			var s = '<ul>';
			s += '<li>最小速率：'+numberformats(json.minupbps) + 'bps</li>';
			s += '<li>最大速率：'+numberformats(json.maxupbps) + 'bps</li>';
			s += '<li>平均速率：'+numberformats(json.avgupbps)+'bps</li>';
			s += '<li>累计流量：'+numberformats(json.allupbytes)+'B<li>';
			$("#upbps_extr").html(s);
			s = '<ul>';
			s += '<li>最小速率：'+numberformats(json.mindownbps) + 'bps</li>';
			s += '<li>最大速率：'+numberformats(json.maxdownbps) + 'bps</li>';
			s += '<li>平均速率：'+numberformats(json.avgdownbps)+'bps</li>';
			s += '<li>累计流量：'+numberformats(json.alldownbytes)+'B<li>';
			$("#downbps_extr").html(s);
		}
	});
}

function drawtrend()
{
	var devid = getdevice();
	var linkid = $("#linkid").val();
	// var appid = -1;
	var appid = $("#hidappid").val();
	var cname = "所有协议";

	var datetime = $("#datetime").val();
	if (datetime == "") {
		layer.msg("请选择要查询的时间范围.");
		return false;
	}
	var d = datetime.split('~');
	starttime = d[0];
	endtime = d[1];
	
	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../App/appgroup_trend_stacking.php',
		data:{devid:devid, linkid:linkid, tmstart:starttime, tmend:endtime, appid: appid, errname:errname},
		type:'post',
		dataType:'json',
		success:function(json) {
			cluster_load_hide();
			apptrend_graph("bpsup", json.xdate, json.up);
			apptrend_graph("bpsdown", json.xdate, json.down);
			apptrend_graph("bpsflow", json.xdate, json.flow);

			var s = '<ul>';
			s += '<li>最小速率：'+numberformats(json.minupbps) + 'bps</li>';
			s += '<li>最大速率：'+numberformats(json.maxupbps) + 'bps</li>';
			s += '<li>平均速率：'+numberformats(json.avgupbps)+'</li>';
			s += '<li>累计流量：'+numberformats(json.allupbytes)+'B<li>';
			$("#upbps_extr").html(s);
			s = '<ul>';
			s += '<li>最小速率：'+numberformats(json.mindownbps) + 'bps</li>';
			s += '<li>最大速率：'+numberformats(json.maxdownbps) + 'bps</li>';
			s += '<li>平均速率：'+numberformats(json.avgdownbps)+'bps</li>';
			s += '<li>累计流量：'+numberformats(json.alldownbytes)+'B<li>';
			$("#downbps_extr").html(s);
		}
	});
}

var upchart, dnchart, flowchart;
function apptrend_graph(render, xdate, data)
{
	var dom = document.getElementById(render);
	var title = "";
	switch(render) {
	case "bpsup":
		upchart = echarts.init(dom, 'macarons');
		title = "上行速率趋势图/bps";
		tag = '上行速率';
		btnid = "upchart-label-sel";
		break;
	case "bpsdown":
		dnchart = echarts.init(dom, 'macarons');
		title = "下行速率趋势图/bps";
		tag = '下行速率';
		btnid = "downchart-label-sel";
		break;
	case "bpsflow":
		flowchart = echarts.init(dom, 'macarons');
		title = "连接数趋势图";
		tag = '连接数';
		btnid = "flowchart-label-sel";
		break;
	}

	var option = {
		tooltip: {
			trigger: 'axis',
			position: function (pt) {
				return [pt[0]+10, '0%'];
			},
			textStyle: {
				fontSize: 10
			},
			formatter: function(params, ticket, callback) {
				var name = h = "";
				var total = 0;
				for (i = 0; i < params.length; i++) {
					if (name == "") {
						name = unixtimetodate(params[i].name);
						h += name;
					}
					total += params[i].value;
					h += '<br/>' + params[i].seriesName + ': ' + numberformats(params[i].value);
				}
				h += '<br/>总：'+ numberformats(total);
				return h;
			}
		},
		title: {
			text: title,
			left: '1%',
			top:0,
			textStyle: {
				fontSize: 12,
				color: '#555'
			}
		},
		xAxis: {
			type: 'category',
			boundaryGap: false,
			splitLine: {
				show: true 
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				},
				formatter:function(value, index) {
					var dt = new Date();
					dt.setTime(value * 1000);
					return dt.getDate()+ '/'+dt.getHours()+':'+dt.getMinutes();
				}
			},
			data: xdate
		},
		grid: {
			left: '5%',
			top: '15%',
			right:'3%'
		},
		legend: {
			show: true,
			right: '0',
			itemWidth:10,
			itemHeight:10,
			textStyle: {
				fontSize: 10,
				color: '#000'
			},
			selected:{}
		},
		yAxis: {
			type: 'value',
			name: null,
			//nameLocation: 'end',
			splitLine: {
				show: true
			},
			axisTick:{
				interval:6
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				},
				formatter: function(value, index) {
					return (render != "bspflow") ? numberformats(value) : value;
				}
			}
		},
		series: [] 
	};

	var item, selected_item = {};
	for (i = 0; i < data.length; i++) {
		item = {
			name: data[i].name, 
			symbol: "none", 
			type: 'line', 
			stack: '总量', 
			data: data[i].data, 
			lineStyle: {normal: {width: 0}}, 
			areaStyle: {}
		};
		selected_item[data[i].name] = true;
		option.series.push(item);
	}
	option.legend.selected = selected_item;
	$("#"+btnid).unbind("click");
	switch(render) {
	case "bpsup":
		upchart.setOption(option, true);
		$('#'+btnid).click(function(){
			var option = upchart.getOption();
			for(var key in option.legend[0].selected) {
				var v = option.legend[0].selected[key];
				option.legend[0].selected[key] = v == false ? true : false;
			}
			upchart.setOption(option, true);
		});
		upchart.getZr().off('click');
		upchart.getZr().on('click',function (params) {
			var pointInPixel= [params.offsetX, params.offsetY];
			if (upchart.containPixel('grid',pointInPixel)) {
				var pointInGrid = upchart.convertFromPixel({seriesIndex:0},pointInPixel);
				var xIndex = pointInGrid[0];
				var op = upchart.getOption();
				var xdate = op.xAxis[0].data[xIndex];
				focus_trend(xdate);
			}
		});
		break;

	case "bpsdown":
		dnchart.setOption(option, true);
		$('#'+btnid).click(function(){
			var option = dnchart.getOption();
			for(var key in option.legend[0].selected) {
				var v = option.legend[0].selected[key];
				option.legend[0].selected[key] = v == false ? true : false;
			}
			dnchart.setOption(option, true);
		});
		dnchart.getZr().off('click');
		dnchart.getZr().on('click',function (params) {
			var pointInPixel= [params.offsetX, params.offsetY];
			if (dnchart.containPixel('grid',pointInPixel)) {
				var pointInGrid = dnchart.convertFromPixel({seriesIndex:0},pointInPixel);
				var xIndex = pointInGrid[0];
				var op = dnchart.getOption();
				var xdate = op.xAxis[0].data[xIndex];
				focus_trend(xdate);
			}
		});
		break;

	case "bpsflow":
		flowchart.setOption(option, true);
		$('#'+btnid).click(function(){
			var option = flowchart.getOption();
			for(var key in option.legend[0].selected) {
				var v = option.legend[0].selected[key];
				option.legend[0].selected[key] = v == false ? true : false;
			}
			flowchart.setOption(option, true);
		});
		
		flowchart.getZr().off('click');
		flowchart.getZr().on('click',function (params) {
			var pointInPixel= [params.offsetX, params.offsetY];
			if (flowchart.containPixel('grid',pointInPixel)) {
				var pointInGrid = flowchart.convertFromPixel({seriesIndex:0},pointInPixel);
				var xIndex = pointInGrid[0];
				var op = flowchart.getOption();
				var xdate = op.xAxis[0].data[xIndex];
				focus_trend(xdate);
			}
		});
		break;
	}

}

function focus_trend(xdate)
{
	if ($("#logversion").val() == "1")
		return;

	var devid = getdevice();
	var appid = $("#hidappid").val();
	ShowWindow("../user_behavior/session_sum.php?devid="+devid+"&appid="+appid+"&focus_time="+xdate, "_blank", 1000, 600);
}

</script>
<?php
echo getdevice(0);
?>
<div class="outer">
	<div class="layui-form">
		<div class="layui-form-item">
			<label class="layui-form-label" style="width:50px">选择设备</label>
			<div class="layui-form-mid"><a href="javascript:opendevicelist()">设备列表</a></div>
			<label class="layui-form-label" style="width:50px">数据链路</label>
			<div class="layui-input-inline">
				<select id="linkid">
					<option value="-1">任意链路</option>
					<option value="1">网桥1</option><option value="2">网桥2</option>
					<option value="3">网桥3</option><option value="4">网桥4</option>
					<option value="5">虚拟链路1</option><option value="6">虚拟链路2</option>
					<option value="7">虚拟链路3</option><option value="8">虚拟链路4</option>
				</select>
			</div>
			<label class="layui-form-label" style="width:50px">选择协议</label>
			<div class="layui-input-inline" style="width:100px;">
				<input type="text" id="appcname" value="任意" class="layui-input" onclick="showapptree()" />
				<input type="hidden" value="-1" id="hidappid" />
			</div>
			<label class="layui-form-label" style="width:50px">时间范围</label>
			<div class="layui-input-inline" style="width:300px;">
				<input type="text" name="datetime" id="datetime" class="layui-input">
				<icon class="layui-icon layui-icon-date dateicon"></icon>
			</div>
			<div class="layui-input-inline" style="width:50px;">
				<button class="layui-btn layui-btn-normal layui-btn-xs" onclick="appgroup_pie()" />
					<icon class="layui-icon layui-icon-search"></icon>查询
				</button>
			</div>
			<div class="layui-input-inline" style="width:65px;">
				<button class="layui-btn layui-btn-normal layui-btn-xs" onclick="location.href='../download.php?filename=apppie_list.xls'" />
					<icon class="layui-icon layui-icon-export"></icon>EXCEL
				</button>
			</div>
			<div class="layui-input-inline" style="width:100px;">
				<input type="checkbox" name="zero_label_state" checked title="ZERO TAG" />
			</div>
	       	</div>
	</div>
	

	<div id="appgroupcolumn" style="float:left;height:250px;margin-top:10px;border:1px solid #ddd;"></div>
	<div id="appgrouppie_down" style="float:left;height:250px;margin:10px 0 0 10px;border:1px solid #ddd;"></div>
	<div id="appgrouppie_up" style="float:left;height:250px;margin:10px 0 0 10px;border:1px solid #ddd;"></div>
	<div class="clearfloat"></div>
	<div style="position:relative;">
		<div id="bpsdown" style="position:relative;height:250px;margin-top:10px;overflow:hidden;border:1px solid #ddd;"></div>
		<div id="bpsup" style="position:relative;height:250px;margin-top:10px;overflow:hidden;border:1px solid #ddd;"></div>
		<div id="bpsflow" style="height:250px;margin-top:10px;overflow:hidden;border:1px solid #ddd;"></div>
		<div style="position:absolute;left:150px;top:0;">
			<button class="layui-btn layui-btn-primary layui-btn-xs" flag=0 id="downchart-label-sel" />
				<icon class="layui-icon layui-icon-ok"></icon>选择
			</button>
	       	</div>
		<div style="position:absolute;left:150px;top:262px;">
			<button class="layui-btn layui-btn-primary layui-btn-xs" flag=0 id="upchart-label-sel" />
				<icon class="layui-icon layui-icon-ok"></icon>选择
			</button>
	       	</div>
		<div style="position:absolute;left:150px;top:524px;">
			<button class="layui-btn layui-btn-primary layui-btn-xs" flag=0 id="flowchart-label-sel" />
				<icon class="layui-icon layui-icon-ok"></icon>选择
			</button>
	       	</div>
		<div style="position:absolute;left:50px;top:225px;">
			<div id="downbps_extr" class="listhorizontal"></div>
	       	</div>
		<div style="position:absolute;left:50px;top:487px;">
			<div id="upbps_extr" class="listhorizontal"></div>
	       	</div>
		<div style="position:absolute;left:50px;top:764px;">
			<div id="flow_extr" class="listhorizontal"></div>
	       	</div>
			
		<input type="hidden" value="<?=$_SESSION["palog_username"]?>" id="username" />
	</div>
</div>
<?php
exec(PANALOGEYE." receiver stat", $out, $ret);
$panabittm = $localtm = "";
$longpanabit = $longlocal = 0;
foreach($out as $val) {
	$ds = explode('=', trim($val));
	if ($ds[0] == "_panabittm") {
		if ($ds[1] != "0") {
			$panabittm = date("Y-m-d H:i:s", $ds[1]);
			$longpanabit = $ds[1];
		}
	}
	if ($ds[0] == "_localtm") {
		if ($ds[1] != "0") {
			$localtm = date("Y-m-d H:i:s", $ds[1]);
			$longlocal = $ds[1];
		}
	}
}
$difftime = 0;
if ($longpanabit != 0 && $longlocal != 0)
	$difftime = (int)(abs($longpanabit - $longlocal) / 60);
if ($localtm != "" || $panabittm != "") {
	echo '<div class="rightbox my-div-shadow">';
	echo "<div class='title'>";
	echo "<div style='float:left; padding:6px 10px; font-weight:bold;'>系统时间</div>";
	echo "<div style='float:right; padding:6px 10px; font-weight:bold;'><a href='javascript:myclose()'>X</a></div>";
	echo "</div>";
	echo "<div style='clear:both;'></div>";
	echo "<div style='padding:6px 10px;'>设备时间：$panabittm</div>";
	echo "<div style='padding:6px 10px;'>本地时间：$localtm</div>";
	echo "<div style='padding:6px 10px;'>时间相差：".$difftime." 分钟</div>";
	echo "</div>";
}
?>
<script type="text/javascript">
layui.use(['form', 'laydate'], function(){
	var form = layui.form, laydate = layui.laydate;
	form.render();

	laydate.render({
		elem:'#datetime'
		,type:'datetime'
		,eventElem: '.dateicon'
		,range:'~'
		,format:'yyyy-MM-dd HH:mm:ss'
		,value:getrangedate(24)
		,isInitValue:true
	});
	
	var username = $("#username").val();
	console.log(username);
	if(username == "admin")
		defpro_appgroup();
	else{
		var checkboxlist = document.getElementsByName("device");
		//console.log(checkboxlist);
		checkboxlist[0].checked = true;
		$("#datetime").val(getrangedate(24));
		appgroup_pie();
	}
	
})
function myclose()
{
	$(".rightbox").remove();
}

	
var w = $(window).width() - 47;
$("#appgroupcolumn").css("width", w / 3 + 'px');
$("#appgrouppie_up").css("width", w / 3 + 'px');
$("#appgrouppie_down").css("width", w / 3 + 'px');

checkaxptable();
showdevicetree();

function lineHide(opt) 
{
	jQuery.each(opt.data, function (i, item) {
		if (item.value === 0) {
			item.labelLine.show = false;
			item.label.show = false;
		}
       	});
}

function showapptree()
{
	if ($('#showapptree_win').length > 0){
		$('#showapptree_win').show();
		$('#showapptree_win').css('z-index', config.zindex++);
		return false;
	}

	$("<div id='showapptree_win'></div>").appendTo("body");

	$('#showapptree_win').load('treepanel.php', function(){
		setWinpos("showapptree_win", 400, 600, "showapptree_con");

		$('#showapptree_win').css('z-index', config.zindex++);

		createtree();

		$("#checkapp").focus();
	});
}

var trees;
function ajaxcheckapp()
{
	var appid = $("#checkapp").val();

	if (appid == ""){
		$("#checklist").html("");
		return false;
	}

	$.post("checkapp.php", {appid:appid}, function(data){
		var res, r, hl = "";
		eval("res="+data);

		for (var i = 0; i < res.result.length; i++){
			r = res.result[i];
			hl += "&nbsp;&nbsp;<a href='javascript:appselect("+r.id+", \""+r.name+"\", \""+r.cname+"\")'>"+r.cname+"</a><br>";
		}

		$("#checklist").html(hl);
	});
}

function appselect(appid, name, cname)
{
	$("#hidappid").val(appid);
	$("#appcname").val(cname);
	$('#showapptree_win').hide();
}
</script>
</body>
</html>

