<?php
date_default_timezone_set("PRC");
header("Content-type:text/html; charset=gb2312");
$doc = "/usr/logd/www";
$tempfile_dir = "/usr/logdata/tmp";
$hours = $argv[2];

if (!file_exists($tempfile_dir))
	mkdir($tempfile_dir);

$stime = time() - 86400;
$pdfname = $tempfile_dir.'/'.date('Ymd', $stime).'_ht_day.pdf';
$weekpdfname = $tempfile_dir.'/ht_'.date('Ymd', $stime).'_ht_week.pdf';
$monthpdfname = $tempfile_dir.'/ht_'.date('Ymd', $stime).'_ht_month.pdf';

if ($hours == 24 && file_exists($pdfname)) exit;
if ($hours == 168 && file_exists($weekpdfname)) exit;
if ($hours == 720 && file_exists($monthpdfname)) exit;

include("$doc/common.php");
set_time_limit(0);
ini_set("memory_limit", -1);

require_once('chinese.php');
require_once ($doc.'/jpgraph/jpgraph.php');
require_once ($doc.'/jpgraph/jpgraph_bar.php');
require_once ($doc.'/jpgraph/jpgraph_pie.php');
require_once ($doc.'/jpgraph/jpgraph_pie3d.php');

class PDF extends PDF_Chinese{}

$devid = 0;
$ipaddr = "0.0.0.0-255.255.255.255";
$strend = date('Y-m-d H:i:s');
$strstart = date('Y-m-d H:i:s', strtotime($strend) - $hours * 3600);
$topn = 20;
$errfile = _CHECKING_STATUS_F.'/ss.st';

$longstart = strtotime($strstart);
$longend = strtotime($strend);

$pdf=new PDF('P', 'mm', 'A4');

$pdf->Open();
$pdf->SetMargins(5, 5, 5);
$pdf->AddPage();
$pdf->SetDisplayMode('real');
$pdf->AddGBFont();

$pdf->SetFont('GB', 'B', 25);
$pdf->SetXY(57, 70);
$pdf->Cell(40,10, '流控日志管理系统报表');
$pdf->Ln();
$pdf->SetX(80);
$pdf->Cell(40,10,'('.date('Y/m/d').')');
$pdf->Ln();

if (file_exists($doc.'/img/logo.jpg'))
	$pdf->Image($doc.'/img/logo.jpg', 75, 90, 50, 15);

$pdf->SetFont('GB', '', 14);
$pdf->Ln(50);

$pdf->SetX(60);
$pdf->Cell(40, 10, '流控设备编号：');
if ($devid == 0)
    $pdf->Cell(40, 10, "所有设备");
else $pdf->Cell(40,10, $devid);
$pdf->Ln();
$pdf->SetX(60);
$pdf->Cell(40, 10, '统计时间段：');
$pdf->Cell(40, 10, date('Y/m/d H:i', $longstart).'-'.date('Y/m/d H:i', $longend));
$pdf->Ln();
$pdf->SetX(60);
$pdf->Cell(40, 10, '报表生成时间：');
$pdf->Cell(40, 10, date('Y/m/d H:i'), 0,1,'L',false);

$dwidth = array(10, 28, 25, 25, 25, 25, 25, 18, 18, 18, 18);
$arcolors = array("#068BC5","#4EB133","#E6561C","#E6EB01","#24C8E3","#62E172", "#F7EE64","#69F5C3","#ACDBFD","#C6C9CA", "#F68F67","#CDE577","#710000","#5D584B","#4572A7");

$pdf->AddPage();

// 内网IP群组

$grpid = 0;
$sort = 'total';
$bexport = 0;
	
$longstart = strtotime($strstart);
$longend = strtotime($strend);

$filename = "iptable".date("YmdHis");

$cmd = LOGDPATH."/bin/logeye iptable iptable_check 'grpid=$grpid' ".
	"longstart=$longstart longend=$longend 'sort=$sort' 'errfile=$errfile' ".
	"iptype=src 'bexport=$bexport' 'filename=$filename'";
exec($cmd, $out, $ret);
	
$rows = $tmp = array();
foreach($out as $val) {
	$ds = explode(' ', $val);
	array_push($rows, array(
		"grpid"=>$ds[0], 
		"grpname"=>iconv("utf-8", "gb2312", $ds[1]), 
		"upbytes"=>(double)$ds[2], 
		"downbytes"=>(double)$ds[3],
		"maxupbps"=>(float)$ds[5],
		"maxdownbps"=>(float)$ds[6]
	));
	array_push($tmp, (float)$ds[6]);
}
/* 用下行峰值速率出图 */
array_multisort($tmp, SORT_DESC, $rows);
// -----------------------------

$xlabels = array();
$yvalues = array();
foreach($rows as $k=>$val){
	if ($k >= 10)
		break;
	array_push($xlabels, $val['grpname']);
       	array_push($yvalues, (double)$val['maxdownbps'] / 1000 / 1000 / 1000);
}

if (count($rows) != 0) {
    $graph = new Graph(1000,300);
    $graph->SetScale("textlin");
    $graph->img->SetMargin(50,50,10,100);
    $graph->title->SetFont(FF_SIMSUN, FS_NORMAL);
    $graph->xaxis->SetFont(FF_SIMSUN, FS_NORMAL);
    $graph->title->Set("(单位:G)");

    $graph->ygrid->SetFill(false);
    $graph->xaxis->SetLabelAngle(50);
    $graph->xaxis->SetTickLabels($xlabels);

    $graph->yaxis->HideLine(false);
    $graph->yaxis->HideTicks(false,false);
    $bplot = new BarPlot($yvalues);
    $bplot->SetFillColor($arcolors);
    $graph->Add($bplot);
    $graph->Stroke($doc."/download/ipgrp.png");

    $pdf->SetFont('GB', 'B', 14);
    $pdf->Cell(40, 10, '内网IP群组');
    $pdf->Ln();
    $pdf->Ln();
    $pdf->Image($doc.'/download/ipgrp.png', $pdf->GetX(), $pdf->GetY(), 200, 80);
    unlink($doc.'/download/ipgrp.png');
    $pdf->Ln();
    $pdf->SetY(110);

    $pdf->SetFillColor(58,110,165);
    $pdf->SetTextColor(255, 255,255);
    $pdf->SetFont('GB', 'B', 10);

    $pdf->Cell(10, 7, "序号", 1, 0, 'C', true);
    $pdf->Cell(40, 7, "群组名称", 1, 0, 'C', true);
    $pdf->Cell(30, 7, "上行流量", 1, 0, 'C', true);
    $pdf->Cell(30, 7, "下行流量", 1, 0, 'C', true);
    $pdf->Cell(30, 7, "总流量", 1, 0, 'C', true);
    $pdf->Cell(30, 7, "上行峰值bps", 1, 0, 'C', true);
    $pdf->Cell(30, 7, "下行峰值bps", 1, 0, 'C', true);
    $pdf->Ln();
	
    $pdf->SetFont('GB', 'B', 10);
    $pdf->SetTextColor(0, 0, 0);
    foreach($rows as $k=>$val){
        $pdf->Cell(10, 7, ($k+1)."", 1, 0, 'C');
        $pdf->Cell(40, 7, $val['grpname'], 1, 0, 'C', false);
        $pdf->Cell(30, 7, dataformat((double)$val['upbytes'])."", 1, 0, 'C', false);
        $pdf->Cell(30, 7, dataformat((double)$val['downbytes'])."", 1, 0, 'C', false);
	$pdf->Cell(30, 7, dataformat((double)$val['upbytes']+(double)$val['downbytes'])."", 1, 0, 'C', false);
	$pdf->Cell(30, 7, dataformat((double)$val['maxupbps'])."", 1, 0, 'C', false);
        $pdf->Cell(30, 7, dataformat((double)$val['maxdownbps'])."", 1, 0, 'C', false);

        $pdf->Ln();
    }
}
unset($out);
unset($xlabels);
unset($yvalues);

$pdf->AddPage();
$pdf->SetFont('GB', 'B', 14);
$pdf->Cell(40, 10, '流量流向分布');
$pdf->Ln();
$pdf->Ln();

$devid = 0;
$xlabels = array();
$yvalues = array();
$yy_rows = array();
$ydata = array();

/*
$cmd = LOGDPATH."/bin/logeye flowdir_ext session_app_top devid=$devid longstart=$longstart ".
	"longend=$longend appid=-1 sort=total errfile=$errfile";
*/
$cmd = LOGDPATH."/bin/logeye user_behavior huatong_yysflow longstart=$longstart longend=$longend 'errfile=$errfile'";
exec($cmd, $out, $return);

$yystotal = 0;
if (count($out) > 0){	
	foreach($out as $k=>$val) {
		$ds = explode(' ', $val);
		array_push($xlabels, $ds[1]);
		$yystotal += (double)$ds[4];
		array_push($ydata, (double)$ds[4]);
		array_push($yy_rows, array(
			"yys"=>$ds[0], 
			"cname"=>$ds[1], 
			"upbytes"=>(double)$ds[2], 
			"downbytes"=>(double)$ds[3],
			"total"=>(double)$ds[4],
			"maxup"=>(double)$ds[5],
			"maxdown"=>(double)$ds[6]
		));
	}
	
	if ($yystotal != 0) {
		$graph = new PieGraph(600,350);
		$graph->legend->SetFont(FF_SIMSUN,FS_NORMAL);

		$p1 = new PiePlot($ydata);
		
		$p1->SetSize(0.2);
		$p1->SetCenter(0.35,0.5);
		$p1->SetLegends($xlabels);
		$p1->SetSliceColors($arcolors);
		$graph->Add($p1);
		$graph->Stroke($doc."/download/flowpie.png");

		$pdf->Image($doc.'/download/flowpie.png', $pdf->GetX(), $pdf->GetY(), 200, 80);
		
		$pdf->Ln();
		$pdf->SetY(110);
		$pdf->SetFillColor(58,110,165);
		$pdf->SetTextColor(255, 255,255);
		$pdf->SetFont('GB', 'B', 10);
		$pdf->Cell(10, 7, "序号", 1, 0, 'C', true);
		$pdf->Cell(40, 7, "运营商", 1, 0, 'C', true);
		$pdf->Cell(30, 7, "上行流量", 1, 0, 'C', true);
		$pdf->Cell(30, 7, "下行流量", 1, 0, 'C', true);
		$pdf->Cell(30, 7, "总流量", 1, 0, 'C', true);
		$pdf->Cell(30, 7, "上行峰值bps", 1, 0, 'C', true);
		$pdf->Cell(30, 7, "下行峰值bps", 1, 0, 'C', true);
		$pdf->Ln();

		$pdf->SetTextColor(0, 0, 0);
		$pdf->SetFont('GB', '', 10);

		foreach($yy_rows as $key=>$val){
			$pdf->Cell(10, 7, ($key+1)."", 1, 0, 'C');
			$pdf->Cell(40, 7, $val['cname'], 1, 0, 'C');
			$pdf->Cell(30, 7, dataformat((double)$val['upbytes'])."", 1, 0, 'C');
			$pdf->Cell(30, 7, dataformat((double)$val['downbytes'])."", 1, 0, 'C');
			$pdf->Cell(30, 7, dataformat((double)$val['total'])."", 1, 0, 'C');
			$pdf->Cell(30, 7, dataformat((double)$val['maxup'])."", 1, 0, 'C');
			$pdf->Cell(30, 7, dataformat((double)$val['maxdown'])."", 1, 0, 'C');

			$pdf->Ln();
		}
	}
	unset($out);
	unset($xlabels);
       	unset($yvalues);
}

for ($i = 0; $i < 5; $i++) {
	unset($out);
	$cmd = LOGDPATH."/bin/logeye user_behavior yysgrp_flow yys=$i longstart=$longstart longend=$longend 'errfile=$errfile'";
	exec($cmd, $out, $return);

	switch($i) {
	case 0:
		$yysname = "其它";
		break;
	case 1:
		$yysname = "电信";
		break;
	case 2:
		$yysname = "移动";
		break;
	case 3:
		$yysname = "联通";
		break;
	case 4:
		$yysname = "铁通";
		break;
	}
	
	$pdf->AddPage();
	$pdf->SetFont('GB', 'B', 14);
	$pdf->Cell(40, 10, "$yysname-内网IP群组");
	$pdf->Ln();
	$pdf->Ln();
       	//$pdf->SetY(110);
	
	$pdf->SetFillColor(58,110,165);
	$pdf->SetTextColor(255, 255,255);
	$pdf->SetFont('GB', 'B', 10); 
	$pdf->Cell(10, 7, "序号", 1, 0, 'C', true);
	$pdf->Cell(40, 7, "群组名称", 1, 0, 'C', true);
	$pdf->Cell(30, 7, "上行流量", 1, 0, 'C', true);
	$pdf->Cell(30, 7, "下行流量", 1, 0, 'C', true);
	$pdf->Cell(30, 7, "总流量", 1, 0, 'C', true);
	$pdf->Cell(30, 7, "上行峰值bps", 1, 0, 'C', true);
	$pdf->Cell(30, 7, "下行峰值bps", 1, 0, 'C', true);
       	$pdf->Ln();
	
	$pdf->SetFont('GB', 'B', 10);
	$pdf->SetTextColor(0, 0, 0);
	foreach($out as $k=>$val){
		$ds = explode(' ', $val);
		$pdf->Cell(10, 7, ($k+1)."", 1, 0, 'C');
		$pdf->Cell(40, 7, iconv("utf-8", "gb2312", $ds[1]), 1, 0, 'C', false);
		$pdf->Cell(30, 7, dataformat((double)$ds[2])."", 1, 0, 'C', false);
		$pdf->Cell(30, 7, dataformat((double)$ds[3])."", 1, 0, 'C', false);
		$pdf->Cell(30, 7, dataformat((double)$ds[4])."", 1, 0, 'C', false);
		$pdf->Cell(30, 7, dataformat((double)$ds[5])."", 1, 0, 'C', false);
	       	$pdf->Cell(30, 7, dataformat((double)$ds[6])."", 1, 0, 'C', false);
		
		$pdf->Ln();
	}
}







if ($hours == 24)
    $pdf->Output($pdfname);
else if ($hours == 168)
    $pdf->Output($weekpdfname);
else if ($hours == 720)
    $pdf->Output($monthpdfname);

?>
