<?php
session_start();
$path = dirname(__FILE__);
include($path."/common.php");
if (dashboard_expire()) {
	outputres("no", "超时登录");
	exit;
}

$_SESSION["palog_expiretime"] = time() + 1800;

$action = postval("action");

if ($action == "flowalert_list")
{
	$page = postval("page");
	$limit = postval("limit");

	$start = ($page - 1) * $limit;
	$end = $start + $limit;
	$rows = array();
	$total = 0;
	$path = DASHBOARD_PATH."/dashboard_wlist.txt";
	if (file_exists($path)) {
		$list = file($path);
		$total = count($list);
		if ($end > $total) $end = $total;
		for ($i = $start; $i < $end; $i++) {
			list ($ip, $appid, $appcname, $flow, $up, $down) = explode(' ', $list[$i]);
			array_push($rows, array(
				"obj"=>long2ip($ip),
				"appid"=>$appid,
				"appcname"=>iconv("gb2312", "utf-8", $appcname),
				"flow"=>(int)$flow,
				"up"=>(int)$down,
				"down"=>(int)$up
			));
		}
	}
	$json = array("rows"=>$rows, "totalrecord"=>$total);
	echo json_encode($rows);
}

if ($action == "flowtrend")
{
	$date = $uparray = $downarray = $flowarray = array();
	$path = DASHBOARD_PATH."/assets_flow.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($tag, $tm, $bps) = explode(',', trim($val));
			switch($tag) {
			case "up":
				array_push($date, date("H:i", $tm));
				array_push($uparray, (int)$bps);
				break;

			case "down":
				array_push($downarray, (int)$bps);
				break;

			case "flow":
				array_push($flowarray, (int)$bps);
				break;
			}

		}
	}
	$json = array("date"=>$date, "up"=>$uparray, "down"=>$downarray, "flow"=>$flowarray);
	echo json_encode($json);
}

if ($action == "bitcoin")
{
	$rows = array();

	$path = DASHBOARD_PATH."/assets_bitcoin.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($ip, $flow) = explode(' ', $val);
			array_push($rows, array(
				"obj"=>long2ip($ip), 
				"flow"=>(int)$flow
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "assdelay")
{
	$path = DASHBOARD_PATH."/assets_delay.txt";

	$rows = array();
	if (!file_exists($path)) {
		$json["rows"] = $rows;
		echo json_encode($json);
		exit;
	}

	$list = file($path);
	foreach($list as $val) {
		list($ip, $delay) = explode(' ', $val);
		array_push($rows, array(
			"ip"=>long2ip($ip),
			"delay"=>$delay
		));
       	}

	$json = array("rows"=>$rows);
       	echo json_encode($json);
}

if ($action == "china")
{
	$path = DASHBOARD_PATH."/assets_china.txt";

	$rows = $sort = array();

	if (!file_exists($path)) {
		$json["rows"] = $rows;
		echo json_encode($json);
		exit;
	}

	$list = file($path);
	foreach($list as $val) {
		list($cname, $flow) = explode(',', $val);
		if ($cname == "") continue;
		$cname = iconv("gb2312", "utf-8", $cname);
		array_push($rows, array(
			"name"=>$cname,
			"value"=>(float)$flow
		));

       	}

	$json = array("rows"=>$rows);
       	echo json_encode($json);
}

if ($action == "world")
{
	$path = DASHBOARD_PATH."/assets_world.txt";

	$rows = $sort = array();

	if (!file_exists($path)) {
		$json["rows"] = $rows;
		echo json_encode($json);
		exit;
	}

	$list = file($path);
	foreach($list as $val) {
		list($cname, $flow) = explode(',', $val);
		$cname = iconv("gb2312", "utf-8", $cname);
		if ($flow == 0 || strchr($cname, ".") != false || $cname == "新加坡") 
			continue;
		array_push($rows, array(
			"name"=>$cname,
			"cname"=>$cname,
			"value"=>(float)$flow
		));
       	}
	$json = array("rows"=>$rows);
       	echo json_encode($json);
}

if ($action == "filedownload")
{
	$rows = array();

	$path = DASHBOARD_PATH."/dashboard_appstore.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($fname, $count) = explode(' ', $val);
			if (json_encode($fname) == false)
				$fname = iconv("gb2312", "utf-8", $fname);
			array_push($rows, array(
				"fname"=>$fname, 
				"count"=>(int)$count
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "newdomain")
{
	$rows = array();
	$sorts = array();

	$path = DASHBOARD_PATH."/assets_host.add";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($host, $num) = explode(' ', $val);
			array_push($rows, array(
				"host"=>$host, 
				"num"=>(int)$num,
			));
			array_push($sorts, $num);
		}
	}

	array_multisort($sorts, SORT_DESC, SORT_NUMERIC, $rows);

	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "sensitive")
{
	$rows = array();

	$path = DASHBOARD_PATH."/assets_sensitive.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($port, $num) = explode(' ', $val);
			array_push($rows, array(
				"port"=>$port, 
				"num"=>(int)$num,
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "topport")
{
	$rows = array();

	$path = DASHBOARD_PATH."/assets_port.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($port, $num) = explode(' ', $val);
			array_push($rows, array(
				"port"=>$port, 
				"num"=>(int)$num,
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "applist")
{
	$rows = array();

	$path = DASHBOARD_PATH."/assets_app.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			if ($k >= 10) break;
			list ($name, $cname, $flow, $up, $down) = explode(' ', $val);
			array_push($rows, array(
				"obj"=>iconv("gb2312", "utf-8", $cname), 
				"flow"=>(int)$flow,
				"up"=>(int)$down,
				"down"=>(int)$up
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "tophost")
{
	$rows = array();

	$path = DASHBOARD_PATH."/assets_host.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			if ($k >= 10) break;
			list ($host, $flow, $up, $down) = explode(' ', $val);
			array_push($rows, array(
				"obj"=>$host, 
				"flow"=>(int)$flow,
				"up"=>(int)$down,
				"down"=>(int)$up
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "srclist")
{
	$rows = array();

	$path = DASHBOARD_PATH."/assets_src.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			if ($k >= 10)
				break;
			list ($ip, $flow, $up, $down) = explode(' ', $val);
			array_push($rows, array(
				"obj"=>long2ip($ip), 
				"flow"=>(int)$flow,
				"up"=>(int)$down,
				"down"=>(int)$up
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "dstlist")
{
	$rows = array();

	$path = DASHBOARD_PATH."/assets_dst.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			if ($k >= 10)
				break;
			list ($ip, $flow, $up, $down) = explode(' ', $val);
			array_push($rows, array(
				"obj"=>long2ip($ip), 
				"flow"=>(int)$flow,
				"up"=>(int)$down,
				"down"=>(int)$up
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "settitle")
{
	$title = postval("title");
	
	if (setconfig("assets_title", $title) == false)
		outputres("no", "操作失败");
	else
		outputres("yes", "操作成功");
}

if ($action == "isshowatdashboard")
{
	echo getconfig("flowalert_show_at_dashboard");
}

if ($action == "gettitle")
{
	echo getconfig("assets_title");
}

if ($action == "getnum")
{
	$dst = 0;
	$src = 0;
	$host = 0;

	$dstpath = DASHBOARD_PATH."/assets_dstnum.txt";
	if (file_exists($dstpath)) {
		$list = file($dstpath);
		$dst = trim($list[0]);
	}

	$srcpath = DASHBOARD_PATH."/assets_srcnum.txt";
	if (file_exists($srcpath)) {
		unset($list);
		$list = file($srcpath);
		$src = trim($list[0]);
	}

	$hostpath = DASHBOARD_PATH."/assets_hostnum.txt";
	if (file_exists($hostpath)) {
		unset($list);
		$list = file($hostpath);
		$host = trim($list[0]);
	}

	$json = array("dst"=>$dst, "src"=>$src, "host"=>$host);
	echo json_encode($json);
}

if ($action == "ipgrp_set")
{
	$id = postval("id");
	if (!is_numeric($id)) {
		outputres("no", "参数错误。");
		exit;
	}

	$cmd = PANALOGEYE." alssocket config 'dashboard_assets_grpid=$id'";
	exec($cmd);

	outputres("yes", "");
}

if ($action == "ipgrp_list")
{
	$conn = my_mysql_connect();
	if ($conn) {
		$rows = array();
		$cmd = "select id, grpname from palog.dstipgrp_list";
		if (($result = mysql_query($cmd)) != false) {
			while ($row = mysql_fetch_row($result))
				array_push($rows, array("id"=>$row[0], "name"=>$row[1]));
		}
		mysql_close($conn);

		$curid = getconfig("dashboard_assets_grpid");
		$json = array("rows"=>$rows, "curid"=>$curid);
		echo json_encode($json);
	}
	else {
		outputres("no", "数据库连接失败");
	}
}
