<?php
session_start();
$path = dirname(__FILE__);
include($path."/common.php");
if (dashboard_expire()) {
	outputres("no", "超时登录");
	exit;
}

$_SESSION["palog_expiretime"] = time() + 1800;

$action = postval("action");

if ($action == "mapappset")
{
	$appid	= postval("appid");
	$cname	= postval("cname");

	if (!file_exists(LOG_CONF)) {
		outputres("no", "配置文件不存在");
		exit;
	}

	setconfig("npm_map_appid", $appid);
	setconfig("npm_map_cname", $cname);

	outputres("yes", "");
	exit;
}

if ($action == "setdelaytitle")
{
	$title = postval("title");
	
	if (setconfig("dashboard_delaytitle", $title) == false)
		outputres("no", "操作失败");
	else
		outputres("yes", "操作成功");
}

if ($action == "getdelaytitle")
{
	echo getconfig("dashboard_delaytitle");
}

if ($action == "currentdelay")
{
	$avgclnt = $avgsvr = $avgapp = 0;

	$path = DASHBOARD_PATH."/dashboard_npmtrend.txt";
	if (file_exists($path)) {
		$list = file($path);
		$count = count($list);
		for ($i = $count - 1; $i >= 0; $i--) {
			$obj = $list[$i];
			list($start, $avgclnt, $avgsvr, $avgapp) = explode(' ', trim($obj));
			if ($avgclnt != 0 || $avgsvr != 0 || $avgapp != 0)
				break;
		}
	}

	$json = array("clnt"=>$avgclnt, "svr"=>$avgsvr, "app"=>$avgapp);
	echo json_encode($json);
}

if ($action == "getareadelay")
{
	$path = DASHBOARD_PATH."/dashboard_npm_toparea.txt";
	$china = array();
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list($name, $clnt_cnt, $svr_cnt, $app_cnt, $clnt, $svr, $app) = explode(' ', trim($val));
			$name = iconv("gb2312", "utf-8", $name);
			array_push($china, array(
				"name"=>$name,
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"clnt"=>(int)$clnt,
				"svr"=>(int)$svr,
				"app"=>(int)$app,
			));
		}
	}

	$path = DASHBOARD_PATH."/dashboard_npm_world.txt";
	$world = array();
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list($name, $clnt_cnt, $svr_cnt, $app_cnt, $clnt, $svr, $app) = explode(' ', trim($val));
			$name = iconv("gb2312", "utf-8", $name);
			if (strchr($name, ".") != false || $name == "新加坡") 
				continue;
			array_push($world, array(
				"name"=>$name,
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"clnt"=>(int)$clnt,
				"svr"=>(int)$svr,
				"app"=>(int)$app,
			));
		}
	}
	$json = array("china"=>$china, "world"=>$world);
	echo json_encode($json);
}

if ($action == "npmset_left")
{
	$modid	= postval("id");
	$appid	= postval("appid");
	$cname	= postval("cname");

	if (!file_exists(LOG_CONF)) {
		outputres("no", "配置文件不存在");
		exit;
	}

	setconfig("delay_page_left_".$modid."_appid", $appid);
	setconfig("delay_page_left_".$modid."_cname", $cname);

	outputres("yes", "");
	exit;
}

if ($action == "getappgroupdelay")
{
	$render = postval("render");

	switch($render) {
	case "appgroup_game":
		$path = DASHBOARD_PATH."/dashboard_npm_topdst_game.txt";
		if (!file_exists($path))
			$path = DASHBOARD_PATH."/dashboard_npm_topdst_0.txt";
		break;
	case "appgroup_www":
		$path = DASHBOARD_PATH."/dashboard_npm_topdst_www.txt";
		if (!file_exists($path))
			$path = DASHBOARD_PATH."/dashboard_npm_topdst_1.txt";
		break;
	case "appgroup_dns":
		$path = DASHBOARD_PATH."/dashboard_npm_topdst_dns.txt";
		if (!file_exists($path))
			$path = DASHBOARD_PATH."/dashboard_npm_topdst_2.txt";
		break;
	case "appgroup_video":
		$path = DASHBOARD_PATH."/dashboard_npm_topdst_video.txt";
		if (!file_exists($path))
			$path = DASHBOARD_PATH."/dashboard_npm_topdst_3.txt";
		break;
	case "appgroup_im":
		$path = DASHBOARD_PATH."/dashboard_npm_topdst_im.txt";
		if (!file_exists($path))
			$path = DASHBOARD_PATH."/dashboard_npm_topdst_4.txt";
		break;
	case "appgroup_email":
		$path = DASHBOARD_PATH."/dashboard_npm_topdst_email.txt";
		if (!file_exists($path))
			$path = DASHBOARD_PATH."/dashboard_npm_topdst_5.txt";
		break;
	}

	$rows = array();

	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list($ipaddr, $clnt_cnt, $svr_cnt, $app_cnt, $clnt, $svr, $app) = explode(' ', trim($val));
			array_push($rows, array(
				"ipaddr"=>long2ip($ipaddr),
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"clnt"=>(int)$clnt,
				"svr"=>(int)$svr,
				"app"=>(int)$app,
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "topyys")
{
	$rows = array();

	$path = DASHBOARD_PATH."/dashboard_npm_topyys.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($name, $clnt_cnt, $svr_cnt, $app_cnt, $clnt, $svr, $app) = explode(' ', trim($val));
			array_push($rows, array(
				"name"=>iconv("gb2312", "utf-8", $name),
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"clnt"=>(int)$clnt,
				"svr"=>(int)$svr,
				"app"=>(int)$app,
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "tophost")
{
	$rows = array();

	$path = DASHBOARD_PATH."/dashboard_npm_tophost.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($name, $clnt_cnt, $svr_cnt, $app_cnt, $clnt, $svr, $app) = explode(' ', trim($val));
			array_push($rows, array(
				"name"=>$name,
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"clnt"=>(int)$clnt,
				"svr"=>(int)$svr,
				"app"=>(int)$app,
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "topdst")
{
	$rows = array();

	$path = DASHBOARD_PATH."/dashboard_npm_topdst.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($name, $clnt_cnt, $svr_cnt, $app_cnt, $clnt, $svr, $app) = explode(' ', trim($val));
			array_push($rows, array(
				"name"=>long2ip($name),
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"clnt"=>(int)$clnt,
				"svr"=>(int)$svr,
				"app"=>(int)$app,
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "topsrc")
{
	$rows = array();

	$path = DASHBOARD_PATH."/dashboard_npm_topip.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($name, $clnt_cnt, $svr_cnt, $app_cnt, $clnt, $svr, $app) = explode(' ', trim($val));
			array_push($rows, array(
				"name"=>long2ip($name),
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"clnt"=>(int)$clnt,
				"svr"=>(int)$svr,
				"app"=>(int)$app,
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "topapp")
{
	$rows = array();

	$path = DASHBOARD_PATH."/dashboard_npm_topapp.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $k=>$val) {
			list ($cname, $clnt_cnt, $svr_cnt, $app_cnt, $clnt, $svr, $app) = explode(' ', trim($val));
			$n = iconv("gb2312", "utf-8", $cname);
			array_push($rows, array(
				"name"=>$n,
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"clnt"=>(int)$clnt,
				"svr"=>(int)$svr,
				"app"=>(int)$app,
			));
		}
	}
	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "getlogcount")
{
	$npm_cnt = 0;

	$cmd = PANALOGEYE." receiver stat tag=npm";
	exec($cmd, $out, $ret);
	foreach($out as $obj) {
		list($tag, $val) = explode('=', trim($obj));
		if ($tag == "npm_cnt") {
			$npm_cnt = $val;
			break;
		}
	}

	echo $npm_cnt;
}

if ($action == "npmtrend")
{
	$json = $date = $clnt = $svr = $app = array();

	$path = DASHBOARD_PATH."/dashboard_npmtrend.txt";
	if (file_exists($path)) {
		$list = file($path);
		foreach($list as $val) {
			list($start, $avgclnt, $avgsvr, $avgapp) = explode(' ', $val);

			array_push($date, date("d/H:i:s", $start));
			array_push($clnt, (float)$avgclnt);
			array_push($svr, (float)$avgsvr);
			array_push($app, (float)$avgapp);
		}
	}

	$json = array("date"=>$date, "clnt"=>$clnt, "svr"=>$svr, "app"=>$app);
	echo json_encode($json);
}
















