<?php
session_start();
include("common.php");
if (!chksession()) {
	header("Location: index.php");
	exit;
}

$json = array();
$ncpu = $cpu = $mem = $totalmem = $hper = $hsize = 0;

$version = 0;
exec(PANALOGEYE." receiver stat | grep version", $out, $ret);
foreach($out as $val) {
	list($tag, $v) = explode('=', trim($val));
	if ($tag == "version") {
		$version = $v;
		break;
	}
}
unset($out);

switch($version) {
case 0:		/* free */
	if (file_exists("/tmp/cpustat.log")) {
		$list = file("/tmp/cpustat.log");
		list($ncpu, $cpu, $totalmem, $mem, $hper, $hsize) = explode(' ', $list[0]);
	}

	$json["ipdata"] = "";
	if (isset($_REQUEST["ipdata_checked"])) {
		$ipdata_checked = postval("ipdata_checked");
		if (!$ipdata_checked) {
			$ip = "/usr/logd/bin/ip_data.txt";
			if (file_exists($ip))
				exec("file $ip", $out, $ret);
			if (is_array($out))
				$json["ipdata"] = $out[0];
		}
		else
			$json["ipdata"] = "";
	}

	$json["ncpu"] = $ncpu;
	$json["cpu"] = $cpu;
	$json["mem"] = $mem;
	$json["totalmem"] = (int)($totalmem / 1024 / 1024 / 1024);
	$json["hard"] = trim($hper, "%");
	$json["hsize"] = ($hsize > 1024) ? ceil($hsize / 1024)."T" : $hsize."G";
	echo json_encode($json);
	exit;
case 1:		/* professional */
	$nodes = 0;
	$cmd = PANALOGEYE." node list";
	exec($cmd, $out, $ret);
	foreach($out as $val) {
		list($ipaddr, $uuid, $status, $uptime, $cpu_count, $cpuper, $memsz, $memper, $hardsz, $hardper, $position) = explode(' ', trim($val));
		if ($ipaddr == "ipaddr") continue;
		$nodes++;
		$ncpu += $cpu_count;
		$cpu += $cpuper;
		$mem += $memper;
		$totalmem += $memsz;
		$hsize += $hardsz;
		$hper += $hardper;
	}

	if ($nodes == 0) {
		/* 集群中的节点 */
		if (file_exists("/tmp/cpustat.log")) {
			$list = file("/tmp/cpustat.log");
			list($ncpu, $cpu, $totalmem, $mem, $hper, $hsize) = explode(' ', $list[0]);
		}
		$json["ncpu"] = $ncpu;
		$json["cpu"] = $cpu;
		$json["mem"] = $mem;
		$json["totalmem"] = (int)($totalmem / 1024 / 1024 / 1024);
		$json["hard"] = trim($hper, "%");
		$json["hsize"] = ($hsize > 1024) ? ceil($hsize / 1024)."T" : $hsize."G";
		echo json_encode($json);
	}
	else {
		$json["ncpu"] = $ncpu;
		$json["cpu"] = ($nodes != 0) ? (int)($cpu / $nodes) : 0;
		$json["mem"] = ($nodes != 0) ? (int)($mem / $nodes) : 0;
		$json["totalmem"] = $totalmem;
		$json["hard"] = ($nodes != 0) ? (int)($hper / $nodes) : 0;
		$json["hsize"] = ($hsize > 1024) ? ceil($hsize / 1024)."T" : $hsize."G";
		echo json_encode($json);
	}
	break;
}
?>


