<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	echo '<script type="text/javascript">parent.location.href="../index.php";</script>';
	exit;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" content="no-cache">
<title><?=VERSION?></title>
<script type="text/javascript" src="../js/dtree.js" /></script>
<link type="text/css" rel="stylesheet" href="../css/dtree.css" />
<link type="text/css" rel="stylesheet" href="../css/common.css" />
<link rel="stylesheet" href="../css/ui-lightness/jquery-ui-custom.css">
<script type="text/javascript" src="../js/jquery.min.js"></script>
<script type="text/javascript" src="../js/jquery-ui.min.js"></script>
<script type="text/javascript" src="../js/highcharts.js"></script>
<script type="text/javascript" src="../js/Calendar.js"></script>
<script type="text/javascript" src="../js/common.js"></script>
<script type="text/javascript">
function tcpudp_check()
{
	var devid = getdevice();

	var start = $("#start").val();
	var end = $("#end").val();
	var starttime = start + ' 0:0:0';
	var endtime = end + ' 23:59:59';

	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);
	
	$.ajax({
		url:'../flow_direction/flowdir.php',
		dataType:'json',
		type:'post',
		data:{type:'tcpudp_check', 
			devid:devid, 
			tmstart:starttime, 
			tmend:endtime,
			errname:errname
			},
		success:function(json){
			$("#tcpudp_outer").show();
			
			portpie(json.rows, "render1", "TCP&UDP流量占比");
			portpie(json.counts, "render2", "TCP&UDP连接数占比");
			porttype_column(json, "render3");
			
			typebytes_update(json, "tcp");
			typebytes_update(json, "udp");
			
			cluster_load_hide();
		}
	});
}

function typebytes_update(json, type)
{
	var r, s;
	var len
	
	if (type == "tcp") {
		len = json.tcpbytes.length;
		render = "tcpbytes";
	}
	else {
		len = json.udpbytes.length;
		render = "udpbytes";
	}
	
	var trbg;

	s = '<table style="width:100%;">';
	s += '<tr>';
	s += '<th class="txt-center">序号</th>'+
		'<th class="txt-left">端口</th>'+
		'<th class="txt-right">连接数</th>'+
		'<th class="txt-right">上行流量(Byte)</th>'+
		'<th class="txt-right">下行流量(Byte)</th>'+
		'<th class="txt-right">总流量(Byte)</th>';
	s += '</tr>';
	for (i = 0; i < len; i++) {
		if (type == "tcp")
			r = json.tcpbytes[i];
		else
			r = json.udpbytes[i];

		trbg = '';
		if (i % 2 == 1)
			trbg = 'log-table-tr-toggle-bgcolor-curr';

		s += '<tr class="'+trbg+'">' +
			'<td align="center">'+ (1+i)+'</td>'+
			'<td align="left">'+ r.port+'</td>'+
			'<td align="right">'+ r.count+'</td>'+
			'<td align="right">'+ numberformats(r.upbytes)+'</td>'+
			'<td align="right">'+ numberformats(r.downbytes)+'</td>'+
			'<td align="right">'+ numberformats(r.upbytes+r.downbytes)+'</td>'+
			'</tr>';
	}
	s += '<table>';
	$("#"+render).html(s);
}

function portpie(json, render, title)
{
    var option = {
        chart: {
            renderTo: render,
            defaultSeriesType: 'pie',
			//borderWidth: 1,
			borderColor:'#D3DCEB',
			borderRadius:4
        },
        title: {
            text: title,
			style:{font: '微软雅黑', fontSize:'12px', color:'#666', fontWeight:'bold'}
        },
        subtitle: {
            text: null
        },
        xAxis: {
            categories: [],
            title: {
                text: null
            },
            labels:{
                rotation:-45,
                align:'right',
                style:{font: '微软雅黑', fontSize:'14px', color:'#666', fontWeight:'bold'}
            }
        },
        yAxis: {
            min: 0,
            title: {
                text: 'byte'
            }
        },
        tooltip: {
            formatter: function() {
                return ''+
                    this.point.name +'端口: '+ Highcharts.numberFormat(this.point.percentage, 1) + '%'
            }
        },
        plotOptions: {
            pie: {
				size:'80%',
                allowPointSelect: true,
                cursor: 'pointer',
                showInLegend: true,
                dataLabels: {
                    enabled: true,
					style:{fontSize:'12px', fontWeight:'normal'},
                    formatter: function() {
                        return this.point.name +': '+ Highcharts.numberFormat(this.point.percentage, 1) + '%';
                    },
                },
				point:{
                    events:{
                        click:function(){
							//yys_detail(starttime, endtime, this.yys, this.name, 0);
							portapp(devid, this.name, starttime, endtime);
                        }
                    }},
            }
        },
        legend: {
            enabled:false,
            layout: 'vertical',
            backgroundColor: '#FFFFFF',
            floating: true,
            align: 'right',
            verticalAlign: 'top',
            //x: 425,
            //y: 25,
            labelFormatter: function() {
                return this.name +': '+ Highcharts.numberFormat(this.percentage, 1) + '%';
            }
        },
        credits: {
            enabled: false
        },
        series: [{type:'pie', data:[]}]
    };
	
	option.series[0].data = json;
    
    var chart = new Highcharts.Chart(option);
}

function porttype_column(json, render)
{
    var option = {
        chart: {
            renderTo: render,
            defaultSeriesType: "column",
			zoomType: 'xy',
			//backgroundColor: '#f5f5f5',
			//borderWidth: 1,
			borderColor:'#D3DCEB',
			borderRadius:4
        },
        title: {
            text: 'TCP&UDP流量+访问量柱状图',
			style:{font: '微软雅黑', fontSize:'12px', color:'#666', fontWeight:'bold'}
        },
        subtitle: {
            text: null
        },
        xAxis: {
            categories: [],
			crosshair: true,
            title: {
                text: null
            },
			style:{font: '微软雅黑', fontSize:'14px', color:'#666', fontWeight:'bold'},
            labels:{
                rotation:-45,
                align:'right',
                style:{font: '微软雅黑', fontSize:'14px', color:'#666', fontWeight:'bold'}
            }
        },
        yAxis: [{
            min: 0,
            title: {
                text: 'byte'
            }
        },{
			min: 0,
			title: {
				text: '连接数',
				style: {
					color: '#E6561C'
				}
			},
			labels: {
				//format: '{value}',
				style: {
					color: Highcharts.getOptions().colors[0]
				}
			},
			opposite: true
		}],
        tooltip: {
            formatter: function() {
                return '<b>' + this.x + '端口</b><br/>' +
                    this.series.name + ': ' + numberformats(this.y);
            }
        },
        plotOptions: {
            column: {
				stacking: 'normal',
                cursor:'pointer',
				point:{
                    events:{
                        click:function(){
							//yys_detail(starttime, endtime, this.yys, this.category, 0);
                        }
                    }},
                dataLabels: {
                    enabled: false
                }
            }
        },
        legend: {
            enabled:true
        },
        credits: {
            enabled: false
        },
        series: []
    }

    var c = 0;
	var series = [{name:'上行流量', data:[]}, 
		{name:"下行流量", data:[]}, 
		{name:"访问数", type:'spline', data:[], yAxis: 1}];
	
    for (var i = 0; i < json.rows.length; i++) {
        option.xAxis.categories.push(json.rows[i].name);
		
		series[0].data.push(json.rows[i].upbytes);
		series[1].data.push(json.rows[i].downbytes);
		series[2].data.push(json.counts[i].y);
    }
	option.series = series;

    var chart = new Highcharts.Chart(option);
}
</script>
</head>
<body>
<div class="outer">
	<div class="check-form">
		<ul>
			<li>
				<?php
				echo getdevice();
				?>
			</li>
			<li>
				<label>起始时间</label>
				<?php
				$t = strtotime("now") - 86400;
				?>
				<input type="text" name="start" id="start" style="width:80px" 
					onclick="new Calendar().show(this);" value="<?= date('Y-m-d', $t) ?>" />
			</li>
			<li>
				<label>结束时间</label>
				<input type="text" name="end" id="end" style="width:80px" 
					onclick="new Calendar().show(this);" value="<?= date('Y-m-d') ?>" />
			</li>
			<li>
				<a class="btn-extend-color" onclick="tcpudp_check()">查询</a>
			</li>
		</ul>
		<div class="clearfloat"></div>
	</div>
	<div id="tcpudp_outer" style="display:none;">
		<div id="render1" style="float:left; width:33%;height:300px;margin-top:50px;">
		</div>
		<div id="render2" style="float:left; width:33%;height:300px;margin-top:50px;">
		</div>
		<div id="render3" style="float:left; width:33%;height:300px;margin-top:50px;">
		</div>
		<div style="float:left;width:50%;margin-top:50px;font-size:12px;font-weight:bold;">
			TOP10 TCP端口流量排名
		</div>
		<div style="float:left;width:50%;margin-top:50px;font-size:12px;font-weight:bold;">
			TOP10 UDP端口流量排名
		</div>
		<div id="tcpbytes" class="topapp-list-table" style="float:left;width:50%;">
		</div>
		<div id="udpbytes" class="topapp-list-table" style="float:left;width:49%;margin-left:5px;">
		</div>
	</div>
</div>
<script type="text/javascript">
Highcharts.setOptions({ global: { useUTC: false } });
showdevicetree();
</script>
</body>
</html>

