function yysflow_submit(appid, starttime, endtime, render, imgrender, devid)
{
	var topn = 0;
	var sort = 'all';
	var errname = (new Date()).getTime()+'.st';

	$.ajax({
		url:'ajax_report.php',
		data:{action:'yysflow',
			devid: devid,
			sort: sort, 
			topn:topn, 
			appid:appid, 
			starttime:starttime, 
			endtime:endtime, 
			errname:errname
		},
		type:'post',
		async:false,
		dataType:'json',
		success:function(json) {
			yysflow_graph(json, render, imgrender);
			if (appid == -1 || appid == 1031) {
				var yyslist = '', total = 0;
				for (var i = 0; i < json.x.length; i++)
					total += json.y[i];
				for (var i = 0; i < json.x.length; i++)
					yyslist += json.x[i]+'占用'+(json.y[i]/total * 100).toFixed(2)+'%' + (i < (json.x.length - 1) ? ',' : '');
				if (appid == -1) {
					$("#yyslist").val(yyslist);
					yysflow_columngraph(json, "yysflow_column", "yysflow_columnimg");
				}
				else {
					$("#gameyyslist").val(yyslist);
				}
			}
		}
	});
}

function game_yysflow_submit(appid, starttime, endtime, render, imgrender, devid)
{
	var topn = 0;
	var sort = 'all';
	var errname = (new Date()).getTime()+'.st';

	$.ajax({
		url:'ajax_report.php',
		data:{action:'game_yysflow',
			devid: devid,
			sort: sort, 
			topn:topn, 
			appid:appid, 
			starttime:starttime, 
			endtime:endtime, 
			errname:errname
		},
		type:'post',
		async:false,
		dataType:'json',
		success:function(json) {
			yysflow_graph(json, render, imgrender);
			if (appid == -1 || appid == 1031) {
				var yyslist = '', total = 0;
				for (var i = 0; i < json.x.length; i++)
					total += json.y[i];
				for (var i = 0; i < json.x.length; i++)
					yyslist += json.x[i]+'占用'+(json.y[i]/total * 100).toFixed(2)+'%' + (i < (json.x.length - 1) ? ',' : '');
				if (appid == -1) {
					$("#yyslist").val(yyslist);
					yysflow_columngraph(json, "yysflow_column", "yysflow_columnimg");
				}
				else {
					$("#gameyyslist").val(yyslist);
				}
			}
		}
	});
}

function p2p_yysflow_submit(appid, starttime, endtime, render, imgrender, devid)
{
	var topn = 0;
	var sort = 'all';
	var errname = (new Date()).getTime()+'.st';

	$.ajax({
		url:'ajax_report.php',
		data:{action:'p2p_yysflow',
			devid: devid,
			sort: sort, 
			topn:topn, 
			appid:appid, 
			starttime:starttime, 
			endtime:endtime, 
			errname:errname
		},
		type:'post',
		async:false,
		dataType:'json',
		success:function(json) {
			yysflow_graph(json, render, imgrender);
			if (appid == -1 || appid == 1031) {
				var yyslist = '', total = 0;
				for (var i = 0; i < json.x.length; i++)
					total += json.y[i];
				for (var i = 0; i < json.x.length; i++)
					yyslist += json.x[i]+'占用'+(json.y[i]/total * 100).toFixed(2)+'%' + (i < (json.x.length - 1) ? ',' : '');
				if (appid == -1) {
					$("#yyslist").val(yyslist);
					yysflow_columngraph(json, "yysflow_column", "yysflow_columnimg");
				}
				else {
					$("#gameyyslist").val(yyslist);
				}
			}
		}
	});
}

function yysflow_graph(json, render, imgrender)
{
	var dom = document.getElementById(render);
	var mychart = echarts.init(dom, 'macarons');

	var data = [];
	for (var i = 0; i < json.x.length; i++)
		data.push({name:json.x[i], value:json.y[i]});

	var option = {
		backgroundColor: '#fff',
		animation:false,
		series: [{
			type: 'pie',
			name: '流量',
			radius: ['50%', '60%'],
			center:['50%', '50%'],
			data: data
		}]
	}
	mychart.setOption(option);
	setTimeout(function(){
		var imgurl = mychart.getDataURL();
		$("#"+imgrender).attr("src", (imgurl));
	}, 30000);
}

function yysflow_columngraph(json, render, imgrender)
{
	var dom = document.getElementById(render);
	var mychart = echarts.init(dom, 'macarons');

	var option = {
		xAxis: {
			type: 'category',
			axisLabel: {
				interval: 0,
				rotate: 40,
				color: '#000',
				textStyle: {
					fontSize: 8,
					color: '#000'
				}
			},
			data: json.x
	       	},
		yAxis: {
			type: 'value',
			axisLabel: {
				textStyle: {
					fontSize: '8'
				},
				formatter: function(value, index) { return numberformats(value); }
			}
		},
		animation:false,
		series: [{
			data: json.y,
			type: 'bar',
			showBackground: true,
			backgroundStyle: {
				color: 'rgba(220, 220, 220, 0.8)'
			}
		}]
	};
	mychart.setOption(option);
	//setTimeout(function(){
		var imgurl = mychart.getDataURL();
		$("#"+imgrender).attr("src", (imgurl));
	//}, 5000);
}
