<?php
session_start();
set_time_limit(0);
include(dirname(__file__)."/../common.php");
if (!chksession()) {
	outputres("nocookie", "");
	exit;
}

$action = isset($_REQUEST["action"]) ? postval("action") : "";

if ($action == "npmsum_applist")
{
	$cachefile = postval("cachefile");
	$page = postval("page");
	$limit = postval("limit");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	$sort = postval("sort");
	$bexport = postval("bexport");

	$total = 0;
	$rows = array();
	$start = ($page - 1) * $limit;	
	$cmd = LOGDPATH."/bin/logeye npm npmsum_applist ";
	$cmd .= "'page=$page' 'limit=$limit' 'cachefile=$cachefile' 'errfile=$errfile' 'sort=$sort' 'bexport=$bexport'";
	exec($cmd, $out, $ret);
	if ($bexport) {
		npmsum_appexport($out, $cachefile);
		exit;
	}
	$pos = 0;
	foreach($out as $i=>$val) {
		list($appid, $cname, $count, $to, $delay, $max) = explode(' ', $val);
		if ($appid == "total") {
			$total = $cname;
			continue;
		}
		$pos++;
		array_push($rows, array(
			"id"=>($start + $pos),
			"appid"=>$appid,
			"cname"=>iconv("gb2312", "utf-8", $cname),
			"count"=>$count,
			"total"=>$to,
			"delay"=>$delay,
			"max"=>$max
		));
	}
	$json = array("code"=>0, "msg"=>"", "data"=>$rows, "count"=>$total);
	echo json_encode($json);
}

if ($action == "npmsum_dstlist")
{
	$cachefile = postval("cachefile");
	$page = postval("page");
	$limit = postval("limit");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	$sort = postval("sort");
	$bexport = postval("bexport");

	$total = 0;
	$rows = array();
	$start = ($page - 1) * $limit;	
	$cmd = LOGDPATH."/bin/logeye npm npmsum_dstlist 'page=$page' 'limit=$limit' 'cachefile=$cachefile' 'errfile=$errfile' 'sort=$sort' 'bexport=$bexport'";
	exec($cmd, $out, $ret);
	if ($bexport) {
		npmsum_export($out, $cachefile);
		exit;
	}
	$pos = 0;
	foreach($out as $i=>$val) {
		list($ip, $count, $to, $delay, $max) = explode(' ', $val);
		if ($ip == "total") {
			$total = $count;
			continue;
		}
		$pos++;
		array_push($rows, array(
			"id"=>($start + $pos),
			"ip"=>long2ip($ip),
			"count"=>$count,
			"total"=>$to,
			"delay"=>$delay,
			"max"=>$max
		));
	}
	$json = array("code"=>0, "msg"=>"", "data"=>$rows, "count"=>$total);
	echo json_encode($json);
}

function npmsum_appexport($out, $cachefile)
{
	header('Content-Description:File Transfer');
	header("Content-Type:application/octet-stream");
	header('Content-Transfer-Encoding:binary');
	header("Accept-Ranges: bytes");
	header('Expires:0');
	header('Cache-Control:must-revalidate');
	header('Pragma:public');
	//header("Content-Length:".$filesize);
       	header("Content-Disposition:attachment;filename=".$cachefile.".xls");

	echo iconv("utf-8", "gb2312", "协议地址\t有效连接\t累计连接\t平均时延ms\t最大时延ms\n");
	foreach($out as $val) {
		list($appid, $appcname, $count, $total, $delay, $max) = explode(' ', $val);
		echo $appcname."\t".$count."\t".$total."\t".$delay."\t".$max."\n";
	}
}

function npmsum_export($out, $cachefile)
{
	header('Content-Description:File Transfer');
	header("Content-Type:application/octet-stream");
	header('Content-Transfer-Encoding:binary');
	header("Accept-Ranges: bytes");
	header('Expires:0');
	header('Cache-Control:must-revalidate');
	header('Pragma:public');
	//header("Content-Length:".$filesize);
       	header("Content-Disposition:attachment;filename=".$cachefile.".xls");

	echo iconv("utf-8", "gb2312", "IP地址\t有效连接\t累计连接\t平均时延ms\t最大时延ms\n");
	foreach($out as $val) {
		list($ip, $count, $total, $delay, $max) = explode(' ', $val);
		echo long2ip($ip)."\t".$count."\t".$total."\t".$delay."\t".$max."\n";
	}
}

if ($action == "npmsum_srclist")
{
	$cachefile = postval("cachefile");
	$page = postval("page");
	$limit = postval("limit");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	$sort = postval("sort");
	$bexport = postval("bexport");

	$total = 0;
	$rows = array();
	$start = ($page - 1) * $limit;	
	$cmd = LOGDPATH."/bin/logeye npm npmsum_srclist 'page=$page' 'limit=$limit' 'cachefile=$cachefile' 'errfile=$errfile' 'sort=$sort' 'bexport=$bexport'";
	exec($cmd, $out, $ret);

	if ($bexport) {
		npmsum_export($out, $cachefile);
		exit;
	}
	$pos = 0;
	foreach($out as $i=>$val) {
		list($ip, $count, $to, $delay, $max) = explode(' ', $val);
		if ($ip == "total") {
			$total = $count;
			continue;
		}
		$pos++;
		array_push($rows, array(
			"id"=>($start + $pos),
			"ip"=>long2ip($ip),
			"count"=>$count,
			"total"=>$to,
			"delay"=>$delay,
			"max"=>$max
		));
	}
	$json = array("code"=>0, "msg"=>"", "data"=>$rows, "count"=>$total);
	echo json_encode($json);
}

if ($action == "npm_sum")
{
	$devid = postval("devid");
	$ipaddr = postval("ipaddr");
	$dstip = postval("dstip");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	$appid = postval("appid");
	$domain = postval("domain");
	$account = postval("account");
	$clnt_mindelay = postval("clnt_mindelay");
	$svr_mindelay = postval("svr_mindelay");
	$app_mindelay = postval("app_mindelay");
	$fullmatch = postval("fullmatch");
	$sport = postval("sport");
	$dport = postval("dport");
	$ptype = postval("ptype");
	$areaname = postval("areaname");
	$up_retmix = postval("up_retmix");
	$down_retmix = postval("down_retmix");
	$cachefile = postval("cachefile");
	
	$srciptype = postval("srciptype");
       	$srcipgrp = postval("srcipgrp");
	$dstiptype = postval("dstiptype");
       	$dstipgrp = postval("dstipgrp");

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye npm npm_sum ";
	$cmd .= "'devid=$devid' longstart=$longstart longend=$longend ";
	$cmd .= "'errfile=$errfile' 'page=$page' 'limit=$limit' 'appid=$appid' ";
	$cmd .= "'fullmatch=$fullmatch' 'bexport=$bexport' 'grpid=$srcipgrp' 'iptype=$srciptype'";
	$cmd .= " 'dstiptype=$dstiptype' 'dstipgrp=$dstipgrp'";
	if ($ipaddr != "") $cmd .= " 'ipaddr=$ipaddr'";
	if ($dstip != "") $cmd .= " 'dstip=$dstip'";
	if ($account != "") $cmd .= " 'account=$account'";
	if ($iptype != "") $cmd .= " 'iptype=$iptype'";
	if ($grpid != "") $cmd .= " 'grpid=$grpid'";
	if ($clnt_mindelay > 0) $cmd .= " 'clnt_mindelay=$clnt_mindelay'";
	if ($svr_mindelay > 0) $cmd .= " 'svr_mindelay=$svr_mindelay'";
	if ($app_mindelay > 0) $cmd .= " 'app_mindelay=$app_mindelay'";
	if ($domain != "") $cmd .= " 'domain=$domain'";
	if (!empty($sport)) $cmd .= " 'sport=$sport'";
	if (!empty($dport)) $cmd .= " 'dstportseg=$dport'";
	if ($ptype != 0) $cmd .= " 'ptype=$ptype'";
	if ($areaname != "") $cmd .= " 'areaname=".iconv("utf-8", "gb2312", $areaname)."'";
	$filename = "npm_".date("YmdHis");
	$cmd .= " 'filename=$filename'";
	$cmd .= " 'cachefile=$cachefile'";

	if ($up_retmix > 0) $cmd .= " 'up_retmix=$up_retmix'";
	if ($down_retmix > 0) $cmd .= " 'down_retmix=$down_retmix'";
	exec($cmd, $out, $ret);
	$json = $xdate = $clntdata = $svrdata = $appdata = array();
	foreach($out as $val) {
		list($tag, $end, $avgclnt, $avgsvr, $avgapp) = explode(' ', $val);

		if ($tag == "trend") {
			array_push($xdate, date("d/H:i", $end));
			array_push($clntdata, (int)$avgclnt);
			array_push($svrdata, (int)$avgsvr);
			array_push($appdata, (int)$avgapp);
		}
	}

	$json = array(
		"xdate"=>$xdate, 
		"clntdata"=>$clntdata,
		"svrdata"=>$svrdata,
		"appdata"=>$appdata
	);
	echo json_encode($json);
}

if ($action == "topserver")
{
	$devid = postval("devid");
	$ipaddr = postval("ipaddr");
	$appid = postval("appid");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	$sort = postval("sort");
	$title_sort = postval("title_sort");
	$page = postval("page");
	$limit = postval("limit");
	$bexport = postval("bexport");
	$filename = "npmuser".date("YmdHis");
	$cachefile = postval("cachefile");

	$srciptype = postval("srciptype");
       	$srcipgrp = postval("srcipgrp");

	$dstiptype = postval("dstiptype");
       	$dstipgrp = postval("dstipgrp");
	
	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$md5 = md5($cmd);
	$cmd = LOGDPATH."/bin/logeye npm npm_topserver longstart=$longstart ";
	$cmd .= "longend=$longend 'devid=$devid' 'appid=$appid' 'ipaddr=$ipaddr' ";
	$cmd .= "'bexport=$bexport' 'errfile=$errfile' 'sort=$sort' 'md5=$md5' 'page=$page' ";
	$cmd .= "'limit=$limit' 'filename=$filename' 'grpid=$srcipgrp' 'iptype=$srciptype'";
	$cmd .= " 'cachefile=$cachefile' 'dstiptype=$dstiptype' 'dstipgrp=$dstipgrp'";
	exec($cmd, $out, $ret);

	$json = $rows = $date = $yclnt = $ysvr = $yapp = array();
	foreach($out as $val) {
		$sp = explode(' ', $val);

		if ($sp[0] == "total") {
			$totalrecords = $sp[1];
			continue;
		}
		else
			list($ip, $count, $max_clnt, $max_svr, $max_app, $total_clnt, 
				$total_svr, $total_app, $up, $down, $clnt_cnt, $svr_cnt, $app_cnt) = $sp;
		array_push($rows, array(
			"ip"=>long2ip($ip),
			"count"=>(int)$count,
			"max_clnt"=>(int)$max_clnt,
			"max_svr"=>(int)$max_svr,
			"max_app"=>(int)$max_app,
			"avg_clnt"=>$clnt_cnt == 0 ? 0 : (float)round($total_clnt / $clnt_cnt / 1000, 2),
			"avg_svr"=>$svr_cnt == 0 ? 0 : (float)round($total_svr / $svr_cnt / 1000, 2),
			"avg_app"=>$app_cnt == 0 ? 0 : (float)round($total_app / $app_cnt / 1000, 2),
			"up"=>(float)$up,
			"down"=>(float)$down
		));
	}

	$json = array("rows"=>$rows, "totalrecords"=>$totalrecords);
	echo json_encode($json);
}

if ($action == "serverdealy_config")
{
	$grpid = postval("grpid");

	$cmd = PANALOGEYE." node list";
	exec($cmd, $out, $ret);
	foreach($out as $val) {
		list($ipaddr, $uuid) = explode(' ', $val);	
		if ($ipaddr == "ipaddr") continue;
		if (($fp = fopen("http://".$ipaddr.":4816/sessiptbl.php?action=serverdelay&grpid=$grpid", "r")) != false)
			fclose($fp);
	}
	outputres("yes", "");
}

if ($action == "hosthis_3day")
{
	$devid = postval("devid");
	$datatype = postval("datatype");
	$distime = postval("distime");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$host= postval("host");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$mid = $longend - $longstart;

	switch($distime) {
	case "2":
		$longstart -= $mid;
		$longend -= $mid;
		break;
	case "3":
		$longstart -= 2 * $mid;
		$longend -= 2 * $mid;
		break;
	}

	$cmd = LOGDPATH."/bin/logeye npm npmhost_trend 'devid=$devid' longstart=$longstart longend=$longend 'errfile=$errfile' 'domain=$host'";
	exec($cmd, $out, $ret);

	$json = $date = $data = array();
	foreach($out as $val) {
		list($start, $avgclnt, $avgsvr, $avgapp) = explode(' ', $val);

		array_push($date, date("d/H:i:s", $start));
		switch($datatype) {
		case "clnt":
			array_push($data, (float)$avgclnt);
			break;

		case "svr":
			array_push($data, (float)$avgsvr);
			break;

		case "app":
			array_push($data, (float)$avgapp);
			break;
		}
	}

	$json = array("date"=>$date, "data"=>$data);
	echo json_encode($json);
}

if ($action == "history_3day")
{
	$devid = postval("devid");
	$datatype = postval("datatype");
	$distime = postval("distime");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$appid = isset($_POST["appid"]) ? postval("appid") : -1;
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$mid = $longend - $longstart;

	switch($distime) {
	case "2":
		$longstart -= $mid;
		$longend -= $mid;
		break;
	case "3":
		$longstart -= 2 * $mid;
		$longend -= 2 * $mid;
		break;
	}

	$cmd = LOGDPATH."/bin/logeye user_behavior npmtrend_dump 'devid=$devid'";
	$cmd .= " longstart=$longstart longend=$longend 'errfile=$errfile' 'appid=$appid'";
	exec($cmd, $out, $ret);

	$json = $date = $data = array();
	foreach($out as $val) {
		list($start, $avgclnt, $avgsvr, $avgapp, $uppkts, $dnpkts, $upretpkts, $dnretpkts) = explode(' ', $val);

		array_push($date, date("d/H:i:s", $start));

		switch($datatype) {
		case "clnt":
			array_push($data, (float)$avgclnt);
			break;

		case "svr":
			array_push($data, (float)$avgsvr);
			break;

		case "app":
			array_push($data, (float)$avgapp);
			break;
		}
	}

	$json = array("date"=>$date, "data"=>$data);
	echo json_encode($json);
}

if ($action == "hosttrend")
{
	$devid = postval("devid");
	$host = postval("host");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye npm npmhost_trend 'devid=$devid' longstart=$longstart longend=$longend 'errfile=$errfile' 'domain=$host'";
	exec($cmd, $out, $ret);

	$json = $date = $clnt = $svr = $app = array();
	foreach($out as $val) {
		list($start, $avgclnt, $avgsvr, $avgapp) = explode(' ', $val);

		array_push($date, date("d/H:i:s", $start));
		array_push($clnt, (float)$avgclnt);
		array_push($svr, (float)$avgsvr);
		array_push($app, (float)$avgapp);
	}

	$json = array("date"=>$date, "clnt"=>$clnt, "svr"=>$svr, "app"=>$app);
	echo json_encode($json);
}

if ($action == "npmhost")
{
	$devid = postval("devid");
	$domain = postval("domain");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	$sort = postval("sort");
	$page = postval("page");
	$limit = postval("limit");
	$bexport = postval("bexport");
	$filename = "npmhost".date("YmdHis");
	$cachefile = postval("cachefile");

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$md5 = md5($cmd);
	$cmd = LOGDPATH."/bin/logeye npm npmhost_list longstart=$longstart ";
	$cmd .= "longend=$longend 'devid=$devid' 'domain=$domain' ";
	$cmd .= "'bexport=$bexport' 'errfile=$errfile' 'sort=$sort' 'page=$page' ";
	$cmd .= "'limit=$limit' 'filename=$filename' ";
	$cmd .= " 'cachefile=$cachefile'";
	exec($cmd, $out, $ret);

	$json = $rows = $date = $yclnt = $ysvr = $yapp = array();

	foreach($out as $val) {
		$sp = explode(' ', $val);

		if ($sp[0] == "total") {
			$totalrecords = $sp[1];
			continue;
		}
		else
			list($host, $flowcont, $max_clnt, $max_svr, $max_app, $total_clnt, 
				$total_svr, $total_app, $up, $down, $clnt_cnt, $svr_cnt, $app_cnt) = $sp;
		array_push($rows, array(
			"host"=>$host,
			"count"=>(int)$flowcont,
			"max_clnt"=>(int)$max_clnt,
			"max_svr"=>(int)$max_svr,
			"max_app"=>(int)$max_app,
			"avg_clnt"=>$clnt_cnt == 0 ? 0 : (float)round($total_clnt / $clnt_cnt / 1000, 2),
			"avg_svr"=>$svr_cnt == 0 ? 0 : (float)round($total_svr / $svr_cnt / 1000, 2),
			"avg_app"=>$app_cnt == 0 ? 0 : (float)round($total_app / $app_cnt / 1000, 2),
			"up"=>(float)$up,
			"down"=>(float)$down
		));
	}

	$json = array("rows"=>$rows, "totalrecords"=>$totalrecords);
	echo json_encode($json);
}

if ($action == "delayset")
{
	$max_delay = postval("max_delay");

	if (is_numeric($max_delay) == false) {
		outputres("no", "参数值有误");
		exit;
	}

	$cmd = PANALOGEYE." session config 'max_delay=$max_delay'";
	exec($cmd);
	setconfig("max_delay", $max_delay);
	outputres("yes", "");
}

if ($action == "npm_hostdelay")
{
	$devid = postval("devid");
	$host = postval("host");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye npm npm_hostdelay 'devid=$devid' longstart=$longstart longend=$longend 'errfile=$errfile' 'domain=$host'";
	exec($cmd, $out, $ret);

	$json = $date = $clnt = $svr = $app = array();

	foreach($out as $val) {
		list($start, $avgclnt, $avgsvr, $avgapp) = explode(' ', $val);

		array_push($date, date("d/H:i", $start));
		array_push($clnt, (float)$avgclnt);
		array_push($svr, (float)$avgsvr);
		array_push($app, (float)$avgapp);
	}

	$json = array("date"=>$date, "clnt"=>$clnt, "svr"=>$svr, "app"=>$app);
	echo json_encode($json);
}

if ($action == "ip_applist")
{
	$devid = postval("devid");
	$ip = postval("ip");
	$appid = postval("appid");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	
	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye npm npmip_app 'devid=$devid' longstart=$longstart longend=$longend 'errfile=$errfile' 'appid=$appid' 'ipaddr=$ip'";
	exec($cmd, $out, $ret);

	$json = $rows = array();

	foreach($out as $val) {
		$sp = explode(' ', $val);
		list($appid, $app_cname, $count, $max_clnt, $max_svr, $max_app, $total_clnt, $total_svr, $total_app, $up, $down) = $sp;
		if (json_encode($app_cname) == false)
			$app_cname = iconv("gb2312", "utf-8", $app_cname);
		array_push($rows, array(
			"appid"=>$appid,
			"app_cname"=>$app_cname,
			"count"=>(int)$count,
			"max_clnt"=>(int)$max_clnt,
			"max_svr"=>(int)$max_svr,
			"max_app"=>(int)$max_app,
			"avg_clnt"=>(float)round($total_clnt / $count / 1000, 2),
			"avg_svr"=>(float)round($total_svr / $count / 1000, 2),
			"avg_app"=>(float)round($total_app / $count / 1000, 2),
			"up"=>(float)$up,
			"down"=>(float)$down
		));
	}

	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "server_applist")
{
	$devid = postval("devid");
	$ip = postval("ip");
	$appid = postval("appid");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	
	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye npm npmserver_app 'devid=$devid' longstart=$longstart longend=$longend 'errfile=$errfile' 'appid=$appid' 'ipaddr=$ip'";
	exec($cmd, $out, $ret);

	$json = $rows = array();
	foreach($out as $val) {
		$sp = explode(' ', $val);
		list($appid, $app_cname, $count, $max_clnt, $max_svr, $max_app, $total_clnt, $total_svr, $total_app, $up, $down) = $sp;
		if (json_encode($app_cname) == false)
			$app_cname = iconv("gb2312", "utf-8", $app_cname);
		array_push($rows, array(
			"appid"=>$appid,
			"app_cname"=>$app_cname,
			"count"=>(int)$count,
			"max_clnt"=>(int)$max_clnt,
			"max_svr"=>(int)$max_svr,
			"max_app"=>(int)$max_app,
			"avg_clnt"=>(float)round($total_clnt / $count / 1000, 2),
			"avg_svr"=>(float)round($total_svr / $count / 1000, 2),
			"avg_app"=>(float)round($total_app / $count / 1000, 2),
			"up"=>(float)$up,
			"down"=>(float)$down
		));
	}

	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "iptrend")
{
	$devid = postval("devid");
	$ip = postval("ip");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$appid = isset($_POST["appid"]) ? postval("appid") : -1;

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye npm npmip_trend 'devid=$devid' longstart=$longstart longend=$longend 'errfile=$errfile' 'appid=$appid' 'ipaddr=$ip'";
	exec($cmd, $out, $ret);

	$json = $date = $clnt = $svr = $app = array();

	foreach($out as $val) {
		list($start, $avgclnt, $avgsvr, $avgapp) = explode(' ', $val);

		array_push($date, date("d/H:i:s", $start));
		array_push($clnt, (float)$avgclnt);
		array_push($svr, (float)$avgsvr);
		array_push($app, (float)$avgapp);
	}

	$json = array("date"=>$date, "clnt"=>$clnt, "svr"=>$svr, "app"=>$app);
	echo json_encode($json);
}

if ($action == "servertrend")
{
	$devid = postval("devid");
	$ip = postval("ip");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$appid = isset($_POST["appid"]) ? postval("appid") : -1;

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye npm npmserver_trend 'devid=$devid' longstart=$longstart longend=$longend 'errfile=$errfile' 'appid=$appid' 'ipaddr=$ip'";
	exec($cmd, $out, $ret);

	$json = $date = $clnt = $svr = $app = array();
	foreach($out as $val) {
		list($start, $avgclnt, $avgsvr, $avgapp) = explode(' ', $val);

		array_push($date, date("d/H:i:s", $start));
		array_push($clnt, (float)$avgclnt);
		array_push($svr, (float)$avgsvr);
		array_push($app, (float)$avgapp);
	}

	$json = array("date"=>$date, "clnt"=>$clnt, "svr"=>$svr, "app"=>$app);
	echo json_encode($json);
}

if ($action == "topuser")
{
	$devid = postval("devid");
	$ipaddr = postval("ipaddr");
	$appid = postval("appid");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	$sort = postval("sort");
	$title_sort = postval("title_sort");
	$page = postval("page");
	$limit = postval("limit");
	$bexport = postval("bexport");
	$filename = "npmuser".date("YmdHis");
	$cachefile = postval("cachefile");

	$srciptype = postval("srciptype");
       	$srcipgrp = postval("srcipgrp");
	
	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$md5 = md5($cmd);
	$cmd = LOGDPATH."/bin/logeye npm npm_topuser longstart=$longstart ";
	$cmd .= "longend=$longend 'devid=$devid' 'appid=$appid' 'ipaddr=$ipaddr' ";
	$cmd .= "'bexport=$bexport' 'errfile=$errfile' 'sort=$sort' 'md5=$md5' 'page=$page' ";
	$cmd .= "'limit=$limit' 'filename=$filename' 'grpid=$srcipgrp' 'iptype=$srciptype'";
	$cmd .= " 'cachefile=$cachefile'";
	exec($cmd, $out, $ret);
	$json = $rows = $date = $yclnt = $ysvr = $yapp = array();
	foreach($out as $val) {
		$sp = explode(' ', $val);

		if ($sp[0] == "total") {
			$totalrecords = $sp[1];
			continue;
		}
		else
			list($ip, $count, $max_clnt, $max_svr, $max_app, $total_clnt, 
				$total_svr, $total_app, $up, $down, $clnt_cnt, $svr_cnt, 
				$app_cnt, $ipmark) = $sp;
		array_push($rows, array(
			"ip"=>long2ip($ip),
			"count"=>(int)$count,
			"max_clnt"=>(int)$max_clnt,
			"max_svr"=>(int)$max_svr,
			"max_app"=>(int)$max_app,
			"avg_clnt"=>$clnt_cnt == 0 ? 0 : (float)round($total_clnt / $clnt_cnt / 1000, 2),
			"avg_svr"=>$svr_cnt == 0 ? 0 : (float)round($total_svr / $svr_cnt / 1000, 2),
			"avg_app"=>$app_cnt == 0 ? 0 : (float)round($total_app / $app_cnt / 1000, 2),
			"up"=>(float)$up,
			"down"=>(float)$down,
			"ipmark"=>iconv("gb2312", "utf-8", $ipmark)
		));
	}

	$json = array("rows"=>$rows, "totalrecords"=>$totalrecords);
	echo json_encode($json);
}

if ($action == "npmcountry_check")
{
	$devid = postval("devid");
	$appid = postval("appid");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	
	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye user_behavior npmcountry_check longstart=$longstart longend=$longend 'errfile=$errfile' 'devid=$devid' 'appid=$appid'";
	exec($cmd, $out, $ret);

	$json = $rows = array();

	foreach($out as $val) {
		list($name, $cname, $count, $max_clnt, $max_svr, $max_app, $total_clnt, $total_svr, $total_app, $up, $down, $clnt_cnt, $svr_cnt, $app_cnt) = explode(',', $val);

		$cname = iconv("gb2312", "utf-8", $cname);

		array_push($rows, array(
			"name"=>$name,
			"cname"=>$cname,
			"count"=>(int)$count,
			"max_clnt"=>(int)$max_clnt,
			"max_svr"=>(int)$max_svr,
			"max_app"=>(int)$max_app,
			"total_clnt"=>(int)$total_clnt,
			"total_svr"=>(int)$total_svr,
			"total_app"=>(int)$total_app,
			"up"=>(float)$up,
			"down"=>(float)$down,
			"clnt_cnt"=>(int)$clnt_cnt,
			"svr_cnt"=>(int)$svr_cnt,
			"app_cnt"=>(int)$app_cnt
		));
	}

	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "area_app")
{
	$devid = postval("devid");
	$appid = postval("appid");
	$eventtype = postval("eventtype");	/* china or world */
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$areaname = iconv("utf-8", "gb2312", postval("areaname"));
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	
	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye user_behavior npmapp_check longstart=$longstart longend=$longend 'errfile=$errfile' 'devid=$devid' 'appid=$appid' 'eventtype=$eventtype' 'areaname=$areaname'";
	exec($cmd, $out, $ret);

	$json = $rows = $date = $yclnt = $ysvr = $yapp = array();

	foreach($out as $val) {
		$sp = explode(' ', $val);
		if ($sp[0] == "app") {
			list($tag, $appid, $app_cname, $clnt_cnt, $svr_cnt, $app_cnt, $max_clnt, $max_svr, $max_app, $total_clnt, $total_svr, $total_app, $up, $down) = $sp;
			if (json_encode($app_cname) == false)
				$app_cname = iconv("gb2312", "utf-8", $app_cname);
			array_push($rows, array(
				"appid"=>$appid,
				"app_cname"=>$app_cname,
				"clnt_cnt"=>(int)$clnt_cnt,
				"svr_cnt"=>(int)$svr_cnt,
				"app_cnt"=>(int)$app_cnt,
				"max_clnt"=>(int)$max_clnt,
				"max_svr"=>(int)$max_svr,
				"max_app"=>(int)$max_app,
				"avg_clnt"=>($clnt_cnt != 0) ? round($total_clnt / $clnt_cnt / 1000, 2) : 0,
				"avg_svr"=>($svr_cnt != 0) ? round($total_svr / $svr_cnt / 1000, 2) : 0,
				"avg_app"=>($app_cnt != 0) ? round($total_app / $app_cnt / 1000, 2) : 0,
				"up"=>(float)$up,
				"down"=>(float)$down
			));
		}

		if ($sp[0] == "trend") {
			list($tag, $time, $avg_clnt, $avg_svr, $avg_app) = $sp;
			array_push($date, date("d/H:i:s", $time));
			array_push($yclnt, (float)$avg_clnt);
			array_push($ysvr, (float)$avg_svr);
			array_push($yapp, (float)$avg_app);
		}
	}

	$json = array("rows"=>$rows, "date"=>$date, "yclnt"=>$yclnt, "ysvr"=>$ysvr, "yapp"=>$yapp);
	echo json_encode($json);
}

if ($action == "npmarea_check")
{
	$devid = postval("devid");
	$appid = postval("appid");
	$yys = postval("yys");
	$dstport = postval("dstport");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	
	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye user_behavior npmarea_check longstart=$longstart longend=$longend 'errfile=$errfile' 'devid=$devid' 'appid=$appid' 'yys=$yys' 'dstport=$dstport'";
	exec($cmd, $out, $ret);

	$json = $rows = array();

	foreach($out as $val) {
		list($area, $count, $max_clnt, $max_svr, $max_app, $total_clnt, $total_svr, $total_app, $up, $down, $clnt_cnt, $svr_cnt, $app_cnt) = explode(' ', $val);

		if ($area == "$") continue;
		if (json_encode($area) == false)
			$area = iconv("gb2312", "utf-8", $area);

		array_push($rows, array(
			"area"=>$area,
			"count"=>(int)$count,
			"max_clnt"=>(int)$max_clnt,
			"max_svr"=>(int)$max_svr,
			"max_app"=>(int)$max_app,
			"total_clnt"=>(int)$total_clnt,
			"total_svr"=>(int)$total_svr,
			"total_app"=>(int)$total_app,
			"up"=>(float)$up,
			"down"=>(float)$down,
			"clnt_cnt"=>(int)$clnt_cnt,
			"svr_cnt"=>(int)$svr_cnt,
			"app_cnt"=>(int)$app_cnt
		));
	}

	$json = array("rows"=>$rows);
	echo json_encode($json);
}

if ($action == "npmtrend_dump")
{
	$devid = postval("devid");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$appid = isset($_POST["appid"]) ? postval("appid") : -1;

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);

	$cmd = LOGDPATH."/bin/logeye user_behavior npmtrend_dump 'devid=$devid' longstart=$longstart longend=$longend 'errfile=$errfile' 'appid=$appid'";
	exec($cmd, $out, $ret);

	$json = $date = $clnt = $svr = $app = $arr_uppkts = $arr_dnpkts = $arr_upretpkts = $arr_dnretpkts = array();
	foreach($out as $val) {
		list($start, $avgclnt, $avgsvr, $avgapp, $uppkts, $dnpkts, $upretpkts, $dnretpkts) = explode(' ', $val);

		array_push($date, date("d/H:i:s", $start));
		array_push($clnt, (float)$avgclnt);
		array_push($svr, (float)$avgsvr);
		array_push($app, (float)$avgapp);
		array_push($arr_uppkts, (float)$uppkts);
		array_push($arr_dnpkts, (float)$dnpkts);
		array_push($arr_upretpkts, (float)$upretpkts);
		array_push($arr_dnretpkts, (float)$dnretpkts);
	}

	$json = array("date"=>$date, "clnt"=>$clnt, "svr"=>$svr, "app"=>$app, 
		"uppkts"=>$arr_uppkts, "dnpkts"=>$arr_dnpkts, 
		"upretpkts"=>$arr_upretpkts, "dnretpkts"=>$arr_dnretpkts);
	echo json_encode($json);
}

if ($action == "npm_check")
{
	$devid = postval("devid");
	$ipaddr = postval("ipaddr");
	$dstip = postval("dstip");
	$starttime = postval("starttime");
	$endtime = postval("endtime");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');
	$appid = postval("appid");
	$domain = postval("domain");
	$account = postval("account");
	$page = postval("page");
	$limit = postval("limit");
	$clnt_mindelay = postval("clnt_mindelay");
	$svr_mindelay = postval("svr_mindelay");
	$app_mindelay = postval("app_mindelay");
	$bexport = postval("bexport");
	$fullmatch = postval("fullmatch");
	$sport = postval("sport");
	$dport = postval("dport");
	$ptype = postval("ptype");
	$areaname = postval("areaname");
	$up_retmix = postval("up_retmix");
	$down_retmix = postval("down_retmix");
	$upbytes_gt = postval("upbytes_gt");
	$downbytes_gt = postval("downbytes_gt");
	
	$srciptype = postval("srciptype");
       	$srcipgrp = postval("srcipgrp");
	$dstiptype = postval("dstiptype");
       	$dstipgrp = postval("dstipgrp");

	$longstart = strtotime($starttime);
	$longend = strtotime($endtime);
	
	$username = $_SESSION["palog_username"];
	
	
	
	
	

	$cmd = LOGDPATH."/bin/logeye user_behavior npm_check ";
	$cmd .= "'devid=$devid' longstart=$longstart longend=$longend ";
	$cmd .= "'errfile=$errfile' 'page=$page' 'limit=$limit' 'appid=$appid' ";
	$cmd .= "'fullmatch=$fullmatch' 'bexport=$bexport' 'grpid=$srcipgrp' 'iptype=$srciptype'  'username=$username'";
	$cmd .= " 'dstiptype=$dstiptype' 'dstipgrp=$dstipgrp'";
	if ($ipaddr != "") $cmd .= " 'ipaddr=$ipaddr'";
	if ($dstip != "") $cmd .= " 'dstip=$dstip'";
	if ($account != "") $cmd .= " 'account=$account'";
	if ($iptype != "") $cmd .= " 'iptype=$iptype'";
	if ($grpid != "") $cmd .= " 'grpid=$grpid'";
	if ($clnt_mindelay > 0) $cmd .= " 'clnt_mindelay=$clnt_mindelay'";
	if ($svr_mindelay > 0) $cmd .= " 'svr_mindelay=$svr_mindelay'";
	if ($app_mindelay > 0) $cmd .= " 'app_mindelay=$app_mindelay'";
	if ($domain != "") $cmd .= " 'domain=$domain'";
	if (!empty($sport)) $cmd .= " 'sport=$sport'";
	if (!empty($dport)) $cmd .= " 'dstportseg=$dport'";
	if ($ptype != 0) $cmd .= " 'ptype=$ptype'";
	if ($areaname != "") $cmd .= " 'areaname=".iconv("utf-8", "gb2312", $areaname)."'";
	$filename = "npm_".date("YmdHis");
	$cmd .= " 'filename=$filename'";

	if ($up_retmix > 0) $cmd .= " 'up_retmix=$up_retmix'";
	if ($down_retmix > 0) $cmd .= " 'down_retmix=$down_retmix'";
	
	if ($upbytes_gt > 0) $cmd .= " upbytes_gt=$upbytes_gt";
	if ($downbytes_gt > 0) $cmd .= " downbytes_gt=$downbytes_gt";
	
	
	$yys = getyys();

	$json = $rows = array();
	$totalrecord = 0;
	exec($cmd, $out, $ret);
	foreach($out as $val) {
		list($devid, $appid, $cname, $ptype, $start, $end, $src, $sport, $dst, $dport, 
			$up, $down, $clntdelay, $svrdelay, $appdelay, $pkts1, $pkts2, $retmixpkts1, 
			$retmixpkts2, $acc, $host, $opid, $position, $srcmark, $dstmark) = explode(',', $val);

		if ($devid == "totalrecord") {
			$json["totalrecord"] = $appid;
			continue;
		}

		if (json_encode($acc) == false)
			$acc = iconv("gb2312", "utf-8", $acc);
		if (json_encode($position) == false)
			$position = iconv("gb2312", "utf-8", $position);
		if (json_encode($cname) == false)
			$cname = iconv("gb2312", "utf-8", $cname);
		if (json_encode($host) == false)
			$host = iconv("gb2312", "utf-8", $host);

		$opname = "";
		foreach($yys as $val) {
			if ($val["id"] == $opid) {
				$opname = $val["name"];
				break;
			}
		}

		array_push($rows, array(
			"devid"=>$devid,
			"appid"=>$appid,
			"cname"=>$cname,
			"ptype"=>$ptype,
			"start"=>date("Y-m-d H:i:s", $start),
			"end"=>date("Y-m-d H:i:s", $end),
			"src"=>long2ip($src),
			"sport"=>$sport,
			"dst"=>long2ip($dst),
			"dport"=>$dport,
			"up"=>$up,
			"down"=>$down,
			"clntdelay"=>$clntdelay,
			"svrdelay"=>$svrdelay,
			"appdelay"=>$appdelay,
			"pkts1"=>(int)$pkts1,
			"pkts2"=>(int)$pkts2,
			"retmixpkts1"=>(int)$retmixpkts1,
			"retmixpkts2"=>(int)$retmixpkts2,
			"acc"=>$acc,
			"host"=>$host,
			"opid"=>$opid,
			"opname"=>$opname,
			"position"=>$position,
			"srcmark"=>iconv("gb2312", "utf-8", $srcmark),
			"dstmark"=>iconv("gb2312", "utf-8", $dstmark)
		));
	}

	$json["rows"] = $rows;
	echo json_encode($json);
}














