<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	echo '<script type="text/javascript">parent.location.href="../index.php";</script>';
	exit;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" content="no-cache">
<title><?=$_GET['appcname']?> 协议时延趋势图</title>
<link type="text/css" rel="stylesheet" href="../css/common.css" />
<script type="text/javascript" src="../js/jquery.min.js"></script>
<script type="text/javascript" src="../js/common.js"></script>
<script type="text/javascript" src="../js/echarts.min.js"></script>
<script type="text/javascript" src="../js/macarons.js"></script>
<script type="text/javascript">
function action_submit(render, distime)
{
	var devid = $("#devid").val();
	var appid = $("#appid").val();
	var starttime = $("#starttime").val();
	var endtime = $("#endtime").val();
	var datatype = $("#datatype").val();

	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'ajax_npm.php',
		dataType:'json',
		type: 'post',
		data:{action: 'history_3day', starttime:starttime, endtime:endtime, errname:errname, devid: devid, appid: appid, datatype:datatype, distime:distime},
		success:function(json) {
			cluster_load_hide();
			draw_trend(json.date, json.data, render, datatype, distime);

			if (distime == "1")
				action_submit("render2", "2");
			else
			if (distime == "2")
				action_submit("render3", "3");
		}
	});
}

function draw_trend(xdate, ydata, render, datatype, distime)
{
	var dom = document.getElementById(render);
	var myChart = echarts.init(dom, "macarons");

	var starttime = $("#starttime").val();
	var endtime = $("#endtime").val();

	var unixstart = datetounixtime(starttime);
	var unixend = datetounixtime(endtime);
	var mid = unixend - unixstart;

	switch(distime) {
	case "1":
		starttime = unixtimetodate(unixstart);
		endtime = unixtimetodate(unixend);
		break;

	case "2":
		starttime = unixtimetodate(unixstart - mid);
		endtime = unixtimetodate(unixend - mid);
		break;

	case "3":
		starttime = unixtimetodate(unixstart - mid * 2);
		endtime = unixtimetodate(unixend - mid * 2);
		break;
	}

	switch(datatype) {
	case "clnt":
		title = "客户端时延/ms";
		break;
	case "svr":
		title = "服务时延/ms";
		break;
	case "app":
		title = "应用时延/ms";
		break;
	}

	title += " "+starttime+' '+endtime;

	option = {
		tooltip: {
			trigger: 'axis',
			position: function (pt) {
				return [pt[0], '10%'];
			},
			textStyle: {
				fontSize: 12
			}
		},
		title: {
			text: title,
			left: '1%',
			top:0,
			textStyle: {
				fontSize: 14,
				color: '#555'
			}
		},
		xAxis: {
			type: 'category',
			data: xdate
		},
		grid: {
			left: '8%',
			top: '15%',
			right:'3%'
		},
		yAxis: {
			type: 'value',
			nameLocation: 'end',
			nameTextStyle: {
				fontSize: 12,
				fontFamily: 'Microsoft YaHei'
			},
		},
		series: [{
				name:'平均时延',
				type:'line',
				smooth:true,
				symbol: 'none',
				sampling: 'average',
				itemStyle: {
					//color: 'rgb(225, 70, 131)'
				},
				data: ydata
			}
		]
	};

	myChart.setOption(option);
}
</script>
</head>

<body>
<div class="outer">
	<input type="hidden" value="<?=$_GET['datatype']?>" id="datatype" />
	<input type="hidden" value="<?=$_GET['devid']?>" id="devid" />
	<input type="hidden" value="<?=$_GET['appid']?>" id="appid" />
	<input type="hidden" value="<?=$_GET['appcname']?>" id="appcname" />
	<input type="hidden" value="<?=$_GET['starttime']?>" id="starttime" />
	<input type="hidden" value="<?=$_GET['endtime']?>" id="endtime" />
	<div style="position:relative;" class="npmtrend-nav">
		<div id="render1" style="height:300px;overflow:hidden;margin-top:15px;"></div>
		<div id="render2" style="height:300px;overflow:hidden;margin-top:15px;"></div>
		<div id="render3" style="height:300px;overflow:hidden;margin-top:15px;"></div>
	</div>
</div>
<script type="text/javascript">
action_submit("render1", "1");
</script>
</body>
</html>

