<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	echo '<script type="text/javascript">parent.location.href="../index.php";</script>';
	exit;
}

$id = isset($_GET["id"]) ? $_GET['id'] : "";
$cname = isset($_GET["cname"]) ? $_GET['cname'] : "";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" content="no-cache">
<title><?=VERSION?></title>
<link type="text/css" rel="stylesheet" href="../css/dtree.css" />
<link type="text/css" rel="stylesheet" href="../css/common.css" />
<script type="text/javascript" src="../js/jquery.min.js"></script>
<script type="text/javascript" src="../js/common.js"></script>
<script type="text/javascript" src="../js/Calendar.js"></script>
<script type="text/javascript" src="../js/echarts.min.js"></script>
<script type="text/javascript" src="../js/macarons.js"></script>
<script type="text/javascript" src="../js/dtree.js" /></script>
<script type="text/javascript">
function action_submit()
{
	var devid = getdevice();
	var start = $("#start").val();
	var end = $("#end").val();
	var starthour = $("#starthour").val();
	var endhour = $("#endhour").val();
	var startmin = $("#startmin").val();
	var endmin = $("#endmin").val();
	var starttime = start + ' '+starthour+':'+startmin+':0';
	var endtime = end + ' '+endhour+':'+endmin+':59';

	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'ajax_npm.php',
		dataType:'json',
		type: 'post',
		data:{action: 'npmtrend_dump', starttime:starttime, endtime:endtime, errname:errname, devid: devid},
		success:function(json) {
			cluster_load_hide();

			$(".npmtrend-nav").show();

			draw_trend(json.date, json.clnt, "clntrender");
			draw_trend(json.date, json.svr, "svrrender");
			draw_trend(json.date, json.app, "apprender");
		}
	});
}

function draw_trend(xdate, ydata, render)
{
	var dom = document.getElementById(render);
	var myChart = echarts.init(dom, "macarons");

	switch(render) {
	case "clntrender":
		title = "客户端时延/ms";
		break;
	case "svrrender":
		title = "服务时延/ms";
		break;
	case "apprender":
		title = "应用时延/ms";
		break;
	}

	var fontfamily = "微软雅黑";
	var fontsize = 14;

	option = {
		tooltip: {
			trigger: 'axis',
			position: function (pt) {
				return [pt[0], '10%'];
			},
			textStyle: {
				fontSize: 12
			}
		},
		title: {
			left: '1%',
			text: title,
			top:20,
			textStyle: {
				fontFamily: fontfamily,
				fontSize: 14
			}
		},
		xAxis: {
			type: 'category',
			data: xdate,
			axisLabel: {
				textStyle: {
					fontSize: '10'
				}
			},
		},
		grid: {
			left: '4%',
			right:'3%'
		},
		yAxis: {
			type: 'value',
			nameLocation: 'end',
			nameTextStyle: {
				fontSize: 12,
				fontFamily: 'Microsoft YaHei'
			},
			axisLabel: {
				textStyle: {
					fontSize: '10'
				}
			},
		},
		series: [{
				name:'平均时延',
				type:'line',
				smooth:true,
				symbol: 'none',
				sampling: 'average',
				itemStyle: {
					//color: 'rgb(225, 70, 131)'
				},
				areaStyle: {
				},
				data: ydata
			}
		]
	};

	myChart.setOption(option);
}
</script>
</head>

<body>
<div class="outer">
	<div class="als-nav-header">
		<ul>
			<li class="active"><a href="sys_trend.php">系统时延</a></li>
			<li><a href="app_trend.php">应用时延</a></li>
		</ul>
	</div>
	<div class="check-form">
		<ul>
			<li>
				<?php
				echo getdevice();
				?>
			</li>
			<li>
				<label>起始时间</label>
				<?php
				$t = strtotime("now") - 3600;
				$t2 = strtotime("now");
				?>
				<input type="text" name="start" id="start" style="width:80px" 
					onclick="new Calendar().show(this);" value="<?= date('Y-m-d', $t) ?>" />
				<input type="text" id="starthour" value="<?= date('H', $t)?>" style="width:30px" />时
				<input type="text" id="startmin" value="<?= date('i', $t)?>" style="width:30px" />分
			</li>
			<li>
				<label>结束时间</label>
				<input type="text" name="end" id="end" style="width:80px" 
					onclick="new Calendar().show(this);" value="<?= date('Y-m-d', $t2) ?>" />
				<input type="text" id="endhour" value="<?= date('H', $t2)?>" style="width:30px" /> 时
				<input type="text" id="endmin" value="<?= date('i', $t)?>" style="width:30px" />分
			</li>
			<li>
				<a class="btn-extend-color" onclick="action_submit()">查询</a>
			</li>
		</ul>
		<div class="clearfloat"></div>
	</div>
	<div style="position:relative; margin-top:20px; display:none;" class="npmtrend-nav">
		<div id="clntrender" style="height:300px;overflow:hidden;margin-top:15px;">
		</div>
		<div id="svrrender" style="height:300px;overflow:hidden;margin-top:15px;">
		</div>
		<div id="apprender" style="height:300px;overflow:hidden;margin-top:15px;">
		</div>
		
		<div style="position:absolute;right:10px;top:20px;">
			<a class="layui-btn layui-btn-xs" href="javascript:history_3day('clnt')">对比分析</a>
		</div>
		<div style="position:absolute;right:10px;top:320px;">
			<a class="layui-btn layui-btn-xs" href="javascript:history_3day('svr')">对比分析</a>
		</div>
		<div style="position:absolute;right:10px;top:640px;">
			<a class="layui-btn layui-btn-xs" href="javascript:history_3day('app')">对比分析</a>
		</div>
	</div>
</div>
<script>
showdevicetree();
function history_3day(datatype)
{
	var appcname = "所有协议";

	var devid = getdevice();
	var appid = -1;

	var start = $("#start").val();
	var end = $("#end").val();
	var starthour = $("#starthour").val();
	var endhour = $("#endhour").val();
	var startmin = $("#startmin").val();
	var endmin = $("#endmin").val();
	var starttime = start + ' '+starthour+':'+startmin+':0';
	var endtime = end + ' '+endhour+':'+endmin+':59';

	var url = 'history_3day.php?appid='+appid+'&appcname='+encodeURIComponent(appcname)+'&starttime='+starttime+'&endtime='+endtime+'&devid='+devid+'&datatype='+datatype;

	ShowWindow(url, "", 800, 700);
}
</script>
</body>
</html>

