<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	echo '<script type="text/javascript">parent.location.href="../index.php";</script>';
	exit;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" content="no-cache">
<title><?=VERSION?></title>
<link type="text/css" rel="stylesheet" href="../css/common.css" />
<link rel="stylesheet" href="../css/ui-lightness/jquery-ui-custom.css">
<script type="text/javascript" src="../js/jquery.min.js"></script>
<script type="text/javascript" src="../js/jquery-ui.min.js"></script>
<!--
<script type="text/javascript" src="../js/map.js"></script>
<script type="text/javascript" src="../js/china-data.js"></script>
-->
<script type="text/javascript" src="../js/highcharts.js"></script>
<script type="text/javascript" src="../js/common.js"></script>
<script type="text/javascript" src="../js/echarts.min.js"></script>
<script type="text/javascript" src="../js/macarons.js"></script>
<script type="text/javascript" src="../js/world.js"></script>
<script type="text/javascript" src="../js/china.js"></script>
<script type="text/javascript">
function ipgrp_areaflow()
{
	var devid = 0;
	var grpid = $("#grpid").val();
	var starttime = $("#start").val();
	var endtime = $("#end").val();
	var grpname = $("#grpname").val();
	var ipaddr = "";
	var iptype = "src";
	
	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../user_behavior/ipgrp_handle.php',
		data:{type:'ipgrp_areaflow', grpid: grpid, devid: devid,
			grpname:grpname, starttime:starttime, endtime:endtime, 
			errname:errname, ipaddr: ipaddr, iptype: iptype},
		type:'post',
		dataType:'json',
		success:function(json) {
			cluster_load_hide();
			flowmaps_update(json, "flowmap", "上行");
			topip_graph(json, "toparea10");

			worldflow();
		}
	});
}

function flowmaps_update(json, render, title)
{
	var name_title = "外网用户访问量分布(中国)"

	var subname = '';
	var nameColor = "#000"
	var name_fontFamily ="微软雅黑";
	var subname_fontSize = 0;
	var name_fontSize = 12;
	var mapName = 'china'
	var geoCoordMap = {};
	var toolTipData = [];

	var dom = document.getElementById(render);
	var myChart = echarts.init(dom, "macarons");

	var data = [];

	var max = 0, min = 0;
	for (i = 0; i < json.rows.length; i++) {
		r = json.rows[i];

		data.push({name:r.cname, value:r.flowcont});
		toolTipData.push({name:r.cname, value:[{name:"流量", value:numberformats(r.value)}, {name:"连接数", value:r.flowcont}]});

		if (r.flowcont > max)
			max = r.flowcont;
	}

	myChart.showLoading();
	var mapFeatures = echarts.getMap(mapName).geoJson.features;
	myChart.hideLoading();
	mapFeatures.forEach(function(v) {
		var name = v.properties.name;
		geoCoordMap[name] = v.properties.cp;
	});

	var convertData = function(data) {
		var res = [];
		for (var i = 0; i < data.length; i++) {
			var geoCoord = geoCoordMap[data[i].name];
			if (geoCoord) {
				res.push({ name: data[i].name, value: geoCoord.concat(data[i].value)});
			}
		}
		return res;
	};

	option = {
		title: {
		text: name_title,
		subtext: subname,
		left: '1%',
		top:10,
		textStyle: {
			//color: nameColor,
			fontFamily: name_fontFamily,
			fontSize: 14,
			fontWeight: 'bold'
			}
		},
		tooltip: {
		trigger: 'item',
		formatter: function(params) {
			if (typeof(params.value)[2] == "undefined") {
				var toolTiphtml = ''
				for(var i = 0;i<toolTipData.length;i++){
					if(params.name==toolTipData[i].name){
						toolTiphtml += toolTipData[i].name+':<br>'
						for(var j = 0;j<toolTipData[i].value.length;j++){
							toolTiphtml+=toolTipData[i].value[j].name+':'+toolTipData[i].value[j].value+"<br>"
						}
					}
				}
				return toolTiphtml;
			}
			else {
				var toolTiphtml = ''
				for(var i = 0;i<toolTipData.length;i++){
					if(params.name==toolTipData[i].name){
						toolTiphtml += toolTipData[i].name+':<br>'
						for(var j = 0;j<toolTipData[i].value.length;j++){
							toolTiphtml+=toolTipData[i].value[j].name+':'+toolTipData[i].value[j].value+"<br>"
						}
					}
				}
				return toolTiphtml;
			}
		},
		textStyle: {
			fontSize: 12
		}
		},
		visualMap: {
			show: true,
			itemWidth: 12,
			min: 0,
			max: max,
			left: 'left',
			top: 'middle',
			text: ["高", "低"],
			calculable: true,
			seriesIndex: [1],
			inRange: {
				//color: ["#f5f5f5", "#CC6666", '#f00'],
				color: ['lightskyblue', 'yellow', 'orangered', 'red']
			}
		},
		toolbox: {
		show: true,
		orient: 'vertical',
		left: 'right',
		top: 'center',
		feature: {
			dataView: {
				readOnly: false
			},
			restore: {},
			saveAsImage: {
				show: true,
				title: '保存为图片'
			}
		}
		},
		geo: {
			show: true,
			map: mapName,
			label: {
				normal: {
					show: false
				},
				emphasis: {
					show: false,
				}
			},
			roam: false,
			itemStyle: {
				normal: {
					areaColor: '#031525',
					borderColor: '#3B5077',
				},
				emphasis: {
					areaColor: '#2e8ae3',
				}
			}
		},
		series: [{
			name: '散点',
			type: 'scatter',
			coordinateSystem: 'geo',
			label: {
				normal: {
					formatter: '{b}',
					position: 'right',
					show: false,
					fontWeight:"bold"
				},
				emphasis: {
					show: true
				}
			},
			itemStyle: {
				normal: {
					show: false,
					color: '#2e8ae3',
				}
			}
		},
		{
			type: 'map',
			map: mapName,
			geoIndex: 1,
			aspectScale: 0.75,
			showLegendSymbol: false,
			label: {
				normal: {
					show: false 
				},
				emphasis: {
					show: false,
					textStyle: {
						color: '#fff'
					}
				}
			},
			roam: false,
			itemStyle: {
				normal: {
					areaColor: '#87CEFA',
					borderColor: '#3B5077',
				},
				emphasis: {
					areaColor: '#2e8ae3'
				}
			},
			animation: false,
			data: data
		}]
	};
	myChart.setOption(option);
}

/*
function flowmaps_update(data, render, title)
{
	var maxvalue = 0;
	for (i = 0; i < data.length; i++)
		if (data[i].value > maxvalue)
			maxvalue = data[i].value;

	var dom = document.getElementById(render);
	var myChart = echarts.init(dom, "macarons");

	//var myChart = echarts.init(document.getElementById(render));
	var option = {
		title : {
			text: title+'区域流量数据分布图',
			x:'center',
			textStyle: {
				fontSize: 12,
				fontWeight: 'bold',
				color: '#666'
			}
		},
		tooltip : {
			trigger: 'item',
			textStyle: {
				fontSize: 12,
				fontWeight: 'normal'
			},
			formatter: function(params, ticket, callback){
				return params.name+'：'+numberformats(params.value);
			}
		},
		dataRange: {
			//orient: 'right',
			min: 0,
			max: maxvalue,
			x: 'right',
			y: 'bottom',
			text:['高','低'],           // 文本，默认为数值文本
			calculable : true,
			color: ['#f00', '#CC6666', '#f5f5f5'],
			formatter: function(v) {
				return numberformats(v);
			}
		},
		
		series : [
			{
				name: '区域流量数据分布图',
				type: 'map',
				mapType: 'china',
				//selectedMode : 'multiple',
				itemStyle:{
					normal:{label:{show:true}, borderColor: '#ddd', areaStyle:{color:'f5f5f5'}},
					emphasis:{label:{show:true}}
				},
				data: data 
			}
		]
	}
	myChart.setOption(option);
}
 */

function topip_graph(jsondata, render)
{
	var distype = "column";
	var option = {
		chart: {
			renderTo: render,
			defaultSeriesType: distype,
			//backgroundColor: '#f5f5f5',
			//borderWidth: 1,
			borderColor:'#D3DCEB',
			borderRadius:4
		},
		title: {
			text: '区域流量柱状图(Top10)',
			style:{font: '微软雅黑', fontSize:'12px', color:'#666', fontWeight:'bold'}
		},
		subtitle: {
			text: null
		},
		xAxis: {
			categories: [],
			title: {
				text: null
			},
			labels:{
				rotation:-45,
				align:'right',
				style:{font:'normal 11px Verdana, sans-serif', color:'#000000'}
			}
		},
		yAxis: [{
			min: 0,
			title: {
				text: 'byte'
			}
		},{
			min: 0,
			title: {
				text: '连接数',
				style: {
					color: '#E6561C'
				}
			},
			labels: {
				//format: '{value}',
				style: {
					color: Highcharts.getOptions().colors[0]
				}
			},
			opposite: true
		}],
		tooltip: {
			formatter: function() {
				return '<b>' + this.x + '</b><br/>' +
					this.series.name + ': ' + numberformats(this.y);
			}
		},
		plotOptions: {
			column: {
				stacking: 'normal',
				cursor:'pointer',
				depth: 35,
				point:{
				events:{
					click:function(){
						iptrend(devid, this.category, starttime, endtime);
					}
				}},
				dataLabels: {
					enabled: false
				}
		},
		bar: {
			cursor:'pointer',
			point:{
				events:{
					click:function(){
						iptrend(devid, this.category, starttime, endtime);
					}
				}},
				dataLabels: {
					enabled: false
				}
			}
		},
		legend: {
			enabled:false
		},
		credits: {
			enabled: false
		},
		series: []
	}

	var c = 0;
	var series = [{name:'上行流量', data:[]}, 
		{name:"下行流量", data:[]}];
	
	for (var i = 0; i < jsondata.rows.length; i++) {
		if (i >= 10) break;
		option.xAxis.categories.push(jsondata.rows[i].name);
		series[0].data.push(jsondata.rows[i].up);
		series[1].data.push(jsondata.rows[i].down);
	}
	option.series = series;

	var chart = new Highcharts.Chart(option);
}

function useryysflow()
{
	var devid = 0;
	var grpid = $("#grpid").val();
	var starttime = $("#start").val();
	var endtime = $("#end").val();
	var ipaddr = "";
	var iptype = "src";
	
	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../user_behavior/ipgrp_handle.php',
		data:{type:'useryysflow', devid: devid, ipaddr: ipaddr, 
			starttime:starttime, endtime:endtime, errname:errname, 
			iptype: iptype, grpid: grpid},
		type:'post',
		dataType:'json',
		success:function(json){
			useryysflow_pie(json, "useryysflow", "运营商流量分布图");
			cluster_load_hide();
		}
	});
}

function useryysflow_pie(json, render, title)
{
    var option = {
        chart: {
            renderTo: render,
            defaultSeriesType: 'pie',
			borderColor:'#D3DCEB',
			borderRadius:4
        },
        title: {
            text: title,
		style:{font: '微软雅黑', fontSize:'12px', color:'#666', fontWeight:'bold'}
        },
        subtitle: {
            text: null
        },
        xAxis: {
            categories: [],
            title: {
                text: null
            },
            labels:{
                rotation:-45,
                align:'right',
                style:{font:'normal 11px Verdana, sans-serif', fontWeight:'normal', color:'#000000'}
            }
        },
        yAxis: {
            min: 0,
            title: {
                text: 'byte'
            }
        },
        tooltip: {
            formatter: function() {
                return ''+
                    this.point.name +': '+ Highcharts.numberFormat(this.point.percentage, 1) + '%'
            }
        },
        plotOptions: {
            pie: {
				size:'80%',
                allowPointSelect: true,
                cursor: 'pointer',
                showInLegend: true,
                dataLabels: {
                    enabled: true,
					style:{fontSize:'12px', fontWeight:'normal'},
                    formatter: function() {
                        return this.point.name +': '+ Highcharts.numberFormat(this.point.percentage, 1) + '%';
                    },
                },
				point:{
                    events:{
                        click:function(){
                        }
                    }},
            }
        },
        legend: {
            enabled:false,
            layout: 'vertical',
            backgroundColor: '#FFFFFF',
            floating: true,
            align: 'left',
            verticalAlign: 'top',
            x: 425,
            y: 25,
            labelFormatter: function() {
                return this.name;
            }
        },
        credits: {
            enabled: false
        },
        series: [{type:'pie', data:[]}]
    };

    var c = 0;
    for (var i = 0; i < json.y.length; i++) {
		if (render == "useryysflow2")
			option.series[0].data.push({name:json.x[i], y:json.fl[i], yys: i});
		else
			option.series[0].data.push({name:json.x[i], y:json.y[i], yys: i});
    }
    var chart = new Highcharts.Chart(option);
}

</script>
</head>
<body class="als-body">
<div>
	<?php
		$grpname = $_GET['grpname'];
		$start = $_GET['start'];
		$end = $_GET['end'];
		$grpid = $_GET['grpid'];
		$url1 = "ipgrp_open.php?grpname=$grpname&grpid=$grpid&start=$start&end=$end";
		$url2 = "ipgrp_appgroup.php?grpname=$grpname&grpid=$grpid&start=$start&end=$end";
		$url3 = "ipgrp_distflow.php?grpname=$grpname&grpid=$grpid&start=$start&end=$end";
		$url4 = "ipgrp_host.php?grpname=$grpname&grpid=$grpid&start=$start&end=$end";
	?>
	<div class="als-nav-header">
		<ul>
			<li><a href="<?=$url1?>">内网IP</a></li>
			<li><a href="<?=$url2?>">协议组</a></li>
			<li class="active"><a href="<?=$url3?>">流量流向</a></li>
			<li><a href="<?=$url4?>">Top域名</a></li>
		</ul>
	</div>
	<input type="hidden" value="<?= $_GET['grpname']?>" id="grpname" />
	<input type="hidden" value="<?= $_GET['start']?>" id="start" />
	<input type="hidden" value="<?= $_GET['end']?>" id="end" />
	<input type="hidden" value="<?= $_GET['grpid']?>" id="grpid" />

	<div class="als-content">
		<div class="als-box">
			<div style="float: left; width:48%; height:250px;" id="flowmap"></div>	
			<div style="float: left; width:48%; height:250px;" id="flowworld"></div>	
			<div style="float: left; width:48%; height:250px;" id="toparea10"></div>	
			<div style="float: left; width:48%; height:250px;" id="useryysflow"></div>	
			<div style="clear:both;"></div>
		</div>
	</div>
</div>
<script type="text/javascript" src="../js/echarts/echarts.js"></script>
<script type="text/javascript">
Highcharts.setOptions({ global: { useUTC: false } });

ipgrp_areaflow();
function worldflow()
{
	var devid = 0;
	var grpid = $("#grpid").val();
	var starttime = $("#start").val();
	var endtime = $("#end").val();
	var grpname = $("#grpname").val();
	var ipaddr = "";
	var iptype = "src";
	
	cluster_load_show();
	var errname = (new Date()).getTime()+'.st';
	cluster_get_status(errname);

	$.ajax({
		url:'../user_behavior/ipgrp_handle.php',
		data:{type:'worldflow', grpid: grpid, devid: devid,
			grpname:grpname, starttime:starttime, endtime:endtime, 
			errname:errname, ipaddr: ipaddr, iptype: iptype},
		type:'post',
		dataType:'json',
		success:function(json) {
			cluster_load_hide();

			createmap(json, "flowworld");

			useryysflow();
		}
	});
}

function createmap(json, render)
{
	var dom = document.getElementById(render);
	var mychart = echarts.init(dom, "macarons");

	var d = [];

	var min = 0, max = 0;
	for (i = 0; i < json.length; i++) {
		r = json[i];
		d.push({"name": r.name, "value": [r.flowcont, ,r.cname]})
		if (max < r.flowcont) max = r.flowcont;
	}

	title = '外网用户访问量分布(世界)';
	var a = {"time": title, "data": d};

	var data = [a];

	var option = {
		baseOption: {
			animationDurationUpdate: 1000,
			animationEasingUpdate: 'quinticInOut',
			timeline: {
				show: false,
				axisType: 'category',
				orient: 'vertical',
				autoPlay: false,
				inverse: false,
				//playInterval: 5000,
				left: null,
				right: 5,
				top: 20,
				bottom: 20,
				width: 46,
				height: null,
				label: {
					normal: {
						textStyle: {
							color: '#ddd'
						}
					},
					emphasis: {
						textStyle: {
							color: '#fff'
						}
					}
				},
				symbol: 'none',
				lineStyle: {
					color: '#555'
				},
				checkpointStyle: {
					color: '#bbb',
					borderColor: '#777',
					borderWidth: 1
				},
				controlStyle: {
					showNextBtn: false,
					showPrevBtn: false,
					normal: {
						color: '#666',
						borderColor: '#666'
					},
					emphasis: {
						color: '#aaa',
						borderColor: '#aaa'
					}
				},
				data: data.map(function(ele) {
					return ele.time
				})
			},
			backgroundColor: '#fff',
			title: {
				text: title,
				//left: '1%',
				top: '5%',
				textStyle: {
					fontSize: 14,
				}
			},
			tooltip: {
				textStyle: {
					fontSize: 12
				},
				formatter: function(params) {
					if (params.data && 'value' in params.data) {
						return params.data.value[2] + ': ' + params.data.value[0];
					}
				}
			},
			grid: {
				left: '20%',
				bottom: 20
			},
			series: [{
				id: 'map',
				type: 'map',
				mapType: 'world',
				top: '20%',
				left: 50,
				itemStyle: {
					normal: {
						areaColor: '#3E95DC',
						borderColor: '#5bc1c9'
					},
					emphasis: {
						label: {
							show: true
						},
						areaColor: 'rgba(255,255,255, 0.5)'
					}
				},
				data: []
			}]
		},
		options: []
	}

	option.options.push({
		visualMap: [{
			dimension: 0,
			left: 10,
			top: '15%',
			itemWidth: 12,
			min: min,
			max: max,
			text: ['高', '低'],
			textStyle: {
				color: '#000'
			},
			formatter: '{value}',
			inRange: {
				color: ['lightskyblue', 'yellow', 'orangered', 'red']
			}
		}],
		series: [{
			id: 'map',
			data: data[0].data
		}]
	})

	mychart.setOption(option);
}

</script>
</body>
</html>
